#!/bin/bash
#
#/*
#** IBM Confidential - OCO Source Materials
#** (C) Copyright IBM Corp. 2008, 2009
#** The source code for this program is not published or otherwise divested of its trade secrets,
#** irrespective of what has been deposited with the U.S. Copyright Office.
#*/
#
# Bash script to generate LmiLinks policy with up-to-date IP addresses
#
#set -x

IPV4=`/sbin/ifconfig eth1 | grep "inet addr:" | cut -d ':' -f 2 | cut -d " " -f 1`
IPV6=`/sbin/ifconfig eth1 | grep "inet6 addr:.*Site" | cut -d ':' -f 2- | cut -d " " -f 2 | cut -d '/' -f 1`
HOST=`hostname -f`

#echo "IPV4='$IPV4'"
#echo "IPV6='$IPV6'"
#echo "HOST='$HOST'"

LMILINKS_STUB_PATH="/etc/crm/policies/cml/CommonDocuments/LmiLinks/LmiLinks1_0.xml.in"
LMILINKS_PATH="/etc/crm/policies/cml/CommonDocuments/LmiLinks/LmiLinks1_0.xml"
LMILINKS_OLD_PATH="/etc/crm/policies/cml/CommonDocuments/LmiLinks/LmiLinks1_0.xml.old"

if [ -f $LMILINKS_STUB_PATH ] ; then
  STUB=`cat $LMILINKS_STUB_PATH`
else
  exit 1
fi

if [ x"$STUB" != x"" ] ; then
  NEW_POLICY=`echo "$STUB" | sed "s!@HOST@!$HOST!" | sed "s!@IPV4@!$IPV4!" | sed "s!@IPV6@!$IPV6!"` 
else
  NEW_POLICY=""
  exit 1
fi 

#echo "NEW_POLICY=$NEW_POLICY"

# If policy currently exists, compare contents and update only if different.  If policy doesn't exist, write.
if [ -f $LMILINKS_PATH ] ; then
  CURRENT_POLICY=`cat $LMILINKS_PATH`
  if [ x"$CURRENT_POLICY" != x"$NEW_POLICY" ] ; then
    echo "Policies are different.  Updating policy."
    cp -f "$LMILINKS_PATH" "$LMILINKS_OLD_PATH"
    echo "$NEW_POLICY" > "$LMILINKS_PATH" 
  else
    echo "Policies are the same.  Not updating"
  fi 
fi
