<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lmilinks="http://www.iss.net/cml/CommonDocuments/LmiLinks"  >

<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

<xsl:param name="pDNS" select="''"/>
<xsl:param name="pIPv4" select="''"/>
<xsl:param name="pIPv6" select="''"/>

<xsl:template match="lmilinks:policy">
    <xsl:element name="policy" namespace="http://www.iss.net/cml/CommonDocuments/LmiLinks">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="lmilinks:lmi">
    <xsl:element name="lmi" namespace="http://www.iss.net/cml/CommonDocuments/LmiLinks">
        <xsl:if test="./lmilinks:link[@comment = 'DNS'] or $pDNS != ''">
            <xsl:choose>
                <xsl:when test="$pDNS = ''">
                    <xsl:copy-of select="./lmilinks:link[@comment = 'DNS']" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:call-template name="AddLinkElement">
                        <xsl:with-param name="url" select="concat('https://', $pDNS)"/>
                        <xsl:with-param name="comment" select="'DNS'"/>
                    </xsl:call-template>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
        <xsl:if test="./lmilinks:link[@comment = 'IPv4'] or $pIPv4 != ''">
            <xsl:choose>
                <xsl:when test="$pIPv4 = ''">
                    <xsl:copy-of select="./lmilinks:link[@comment = 'IPv4']" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:call-template name="AddLinkElement">
                        <xsl:with-param name="url" select="concat('https://', $pIPv4)"/>
                        <xsl:with-param name="comment" select="'IPv4'"/>
                    </xsl:call-template>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
        <xsl:if test="./lmilinks:link[@comment = 'IPv6'] or $pIPv6 != ''">
            <xsl:choose>
                <xsl:when test="$pIPv6 = ''">
                    <xsl:copy-of select="./link[@comment = 'IPv6']" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:call-template name="AddLinkElement">
                        <xsl:with-param name="url" select="concat('https://', $pIPv6)"/>
                        <xsl:with-param name="comment" select="'IPv6'"/>
                    </xsl:call-template>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
    </xsl:element>
</xsl:template>

<xsl:template match="lmilinks:phonehome">
    <xsl:element name="phonehome" namespace="http://www.iss.net/cml/CommonDocuments/LmiLinks">
        <xsl:if test="./lmilinks:link[@comment = 'DNS'] or $pDNS != ''">
            <xsl:choose>
                <xsl:when test="$pDNS = ''">
                    <xsl:copy-of select="./lmilinks:link[@comment = 'DNS']" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:call-template name="AddLinkElement">
                        <xsl:with-param name="url" select="concat('https://', $pDNS, '/spa/spa_doheartbeat.php')"/>
                        <xsl:with-param name="comment" select="'DNS'"/>
                    </xsl:call-template>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
        <xsl:if test="./lmilinks:link[@comment = 'IPv4'] or $pIPv4 != ''">
            <xsl:choose>
                <xsl:when test="$pIPv4 = ''">
                    <xsl:copy-of select="./lmilinks:link[@comment = 'IPv4']" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:call-template name="AddLinkElement">
                        <xsl:with-param name="url" select="concat('https://', $pIPv4, '/spa/spa_doheartbeat.php')"/>
                        <xsl:with-param name="comment" select="'IPv4'"/>
                    </xsl:call-template>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
        <xsl:if test="./lmilinks:link[@comment = 'IPv6'] or $pIPv6 != ''">
            <xsl:choose>
                <xsl:when test="$pIPv6 = ''">
                    <xsl:copy-of select="./link[@comment = 'IPv6']" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:call-template name="AddLinkElement">
                        <xsl:with-param name="url" select="concat('https://', $pIPv6, '/spa/spa_doheartbeat.php')"/>
                        <xsl:with-param name="comment" select="'IPv6'"/>
                    </xsl:call-template>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
    </xsl:element>
</xsl:template>

<xsl:template match="lmilinks:notifications">
    <xsl:element name="{name(.)}" namespace="http://www.iss.net/cml/CommonDocuments/LmiLinks">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="lmilinks:notification">
    <xsl:element name="phonehome" namespace="http://www.iss.net/cml/CommonDocuments/LmiLinks">
        <xsl:if test="./lmilinks:link[@comment = 'DNS'] or $pDNS != ''">
            <xsl:choose>
                <xsl:when test="$pDNS = ''">
                    <xsl:copy-of select="./lmilinks:link[@comment = 'DNS']" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:call-template name="AddNotificationLinkElement">
                        <xsl:with-param name="addr" select="$pDNS"/>
                        <xsl:with-param name="uri" select="@URI"/>
                        <xsl:with-param name="comment" select="'DNS'"/>
                    </xsl:call-template>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
        <xsl:if test="./lmilinks:link[@comment = 'IPv4'] or $pIPv4 != ''">
            <xsl:choose>
                <xsl:when test="$pIPv4 = ''">
                    <xsl:copy-of select="./lmilinks:link[@comment = 'IPv4']" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:call-template name="AddNotificationLinkElement">
                        <xsl:with-param name="addr" select="$pIPv4"/>
                        <xsl:with-param name="uri" select="@URI"/>
                        <xsl:with-param name="comment" select="'IPv4'"/>
                    </xsl:call-template>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
        <xsl:if test="./lmilinks:link[@comment = 'IPv6'] or $pIPv6 != ''">
            <xsl:choose>
                <xsl:when test="$pIPv6 = ''">
                    <xsl:copy-of select="./link[@comment = 'IPv6']" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:call-template name="AddNotificationLinkElement">
                        <xsl:with-param name="addr" select="$pIPv6"/>
                        <xsl:with-param name="uri" select="@URI"/>
                        <xsl:with-param name="comment" select="'IPv6'"/>
                    </xsl:call-template>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
    </xsl:element>
</xsl:template>

<xsl:template name="AddLinkElement">
    <xsl:param name="url" select="''"/>
    <xsl:param name="comment" select="''"/>
    <xsl:element name="link" namespace="http://www.iss.net/cml/CommonDocuments/LmiLinks">
        <xsl:attribute name="URL"> <xsl:value-of select="$url"/> </xsl:attribute>
        <xsl:attribute name="comment"> <xsl:value-of select="$comment"/> </xsl:attribute>
    </xsl:element>
</xsl:template>

<xsl:template name="AddNotificationLinkElement">
    <xsl:param name="addr" select="''"/>
    <xsl:param name="uri" select="''"/>
    <xsl:param name="comment" select="''"/>
    <xsl:element name="link" namespace="http://www.iss.net/cml/CommonDocuments/LmiLinks">
        <xsl:choose>
            <xsl:when test="$uri = 'http://www.iss.net/cml/NetworkDefender/command/applyXpu'">
                <xsl:attribute name="URL"> <xsl:value-of select="concat('https://', $addr, '/spa/spa_dotaskrequest.php')"/> </xsl:attribute>
            </xsl:when>
            <xsl:when test="$uri = 'http://www.iss.net/cml/NetworkDefender/command/removeXpu'">
                <xsl:attribute name="URL"> <xsl:value-of select="concat('https://', $addr, '/spa/spa_dotaskrequest.php')"/> </xsl:attribute>
            </xsl:when>
            <xsl:when test="$uri = 'http://www.iss.net/cml/NetworkDefender/command/applyDbtRule'">
                <xsl:attribute name="URL"> <xsl:value-of select="concat('https://', $addr, '/spa/spa_dotaskrequest.php')"/> </xsl:attribute>
            </xsl:when>
            <xsl:when test="$uri = 'http://www.iss.net/cml/NetworkDefender/dbt'">
                <xsl:attribute name="URL"> <xsl:value-of select="concat('https://', $addr, '/dbt')"/> </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
                <xsl:attribute name="URL"> <xsl:value-of select="concat('https://', $addr)"/> </xsl:attribute>
            </xsl:otherwise>
        </xsl:choose>
        <xsl:attribute name="comment"> <xsl:value-of select="$comment"/> </xsl:attribute>
    </xsl:element>
</xsl:template>

<xsl:template match="*">
    <xsl:element name="{name(.)}" namespace="http://www.iss.net/cml/CommonDocuments/LmiLinks">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

</xsl:stylesheet>

