<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fw="http://www.iss.net/cml/NetProtectModule/firewall">

<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
<xsl:param name="pSchemaVersion" select="'5.0.0'"/>

<xsl:template match="fw:policy">
    <xsl:element name="policy" namespace="http://www.iss.net/cml/NetProtectModule/firewall">
        <xsl:copy-of select="@*[name() != 'schema-version']"/>
        <xsl:attribute name="schema-version"> <xsl:value-of select="$pSchemaVersion"/> </xsl:attribute>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="fw:FirewallRule">
    <xsl:element name="FirewallRule" namespace="http://www.iss.net/cml/NetProtectModule/firewall">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="fw:addressPort">
    <xsl:element name="AddressAndPort" namespace="http://www.iss.net/cml/NetProtectModule/firewall">
        <xsl:attribute name="IPVersion">IPv4</xsl:attribute>
        <xsl:attribute name="SourceIP"> <xsl:value-of select="substring-before(fw:source/@addressPortControl,':')"/> </xsl:attribute>
        <xsl:attribute name="SourcePort"> <xsl:value-of select="substring-after(fw:source/@addressPortControl,':')"/> </xsl:attribute>
        <xsl:attribute name="TargetIP"> <xsl:value-of select="substring-before(fw:destination/@addressPortControl,':')"/> </xsl:attribute>
        <xsl:attribute name="TargetPort"> <xsl:value-of select="substring-after(fw:destination/@addressPortControl,':')"/> </xsl:attribute>
    </xsl:element>
</xsl:template>

</xsl:stylesheet>

