<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ipmConfig="http://www.iss.net/cml/NetProtectModule/ipmConfig">

<!--
Usage: Xalan [-p paramName paramValue] [-o outfile] <infile> <xformfile>

Example: /usr/bin/Xalan -i 4 -p pProtectionLevel "'moderate'" -o /tmp/ipmConfig1_1_0.xml ipmConfig1_0_1.xml ipmConfig100.xslt
-->

<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
<xsl:param name="pSchemaVersion" select="'1.1.0'"/> <!-- should be 1.1.0 or greater -->
<xsl:param name="pProtectionLevel" select="''"/>    <!-- moderate, aggressive, paranoid -->

<xsl:template match="ipmConfig:policy">
    <xsl:element name="policy" namespace="http://www.iss.net/cml/NetProtectModule/ipmConfig">
        <xsl:copy-of select="@*[name() != 'schema-version']"/>
        <xsl:choose>
          <xsl:when test="string-length($pSchemaVersion) > 0">
            <xsl:attribute name="schema-version"> <xsl:value-of select="$pSchemaVersion"/> </xsl:attribute>
          </xsl:when>
          <xsl:otherwise>
            <xsl:copy-of select="@schema-version"/>
          </xsl:otherwise>
        </xsl:choose>  
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="ipmConfig:TrustXForce">
    <xsl:element name="TrustXForce" namespace="http://www.iss.net/cml/NetProtectModule/ipmConfig">
        <xsl:choose>
          <xsl:when test="string-length($pProtectionLevel) > 0">
            <xsl:attribute name="ProtectionLevel"> <xsl:value-of select="$pProtectionLevel"/> </xsl:attribute>
          </xsl:when>
          <xsl:otherwise>
            <xsl:copy-of select="@ProtectionLevel"/>
          </xsl:otherwise>
        </xsl:choose>
		<xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<!-- Default copy node rule -->
<xsl:template match="*">
	<xsl:copy-of select="."/>
	<xsl:apply-templates/>
</xsl:template>

</xsl:stylesheet>