<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:se="http://www.iss.net/cml/NetProtectModule/securityEvents">
    <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
    <xsl:template match="se:policy">
        <xsl:copy>
            <xsl:copy-of select="@*[name()!='schema-version']"/>
            <xsl:attribute name="schema-version">5.2.0</xsl:attribute>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="se:securityEventsList">
        <xsl:copy>
            <xsl:copy-of select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="se:responses">
        <xsl:copy>
            <xsl:copy-of select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="se:quarantineResponse[@duration='3900' and @enabled='false' and contains(../../@defaultQuarantine, concat(@name, ' '))]">
        <xsl:copy>
            <xsl:copy-of select="@*[name()!='duration']"/>
            <xsl:attribute name="duration">3600</xsl:attribute>
            <xsl:attribute name="xdefault">true</xsl:attribute>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="text()"/>
    <xsl:template match="*|comment()">
        <xsl:copy-of select="."/>
    </xsl:template>
</xsl:stylesheet>
