<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:tp="http://www.iss.net/cml/NetProtectModule/tuningParameters">

<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
<xsl:param name="pSchemaVersion" select="'1.0.0'"/>

<xsl:template match="tp:policy">
    <xsl:element name="policy" namespace="http://www.iss.net/cml/NetProtectModule/ipmConfig">
        <xsl:copy-of select="@*[name() != 'schema-version']"/>
        <xsl:attribute name="schema-version"> <xsl:value-of select="$pSchemaVersion"/> </xsl:attribute>
        <xsl:apply-templates select="tp:UseXForceDefaults"/>
    </xsl:element>
</xsl:template>

<xsl:template match="tp:UseXForceDefaults">
    <xsl:element name="TrustXForce" namespace="http://www.iss.net/cml/NetProtectModule/ipmConfig">
        <xsl:choose>
            <xsl:when test="@useXForceDefaults = 'true'">
                <xsl:element name="Always" namespace="http://www.iss.net/cml/NetProtectModule/ipmConfig"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:element name="Never" namespace="http://www.iss.net/cml/NetProtectModule/ipmConfig"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:element>
</xsl:template>

</xsl:stylesheet>

