<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:tuningParameters="http://www.iss.net/cml/NetProtectModule/tuningParameters">

<!--
Usage: Xalan [-p paramName paramValue] [-o outfile] <infile> <xformfile>

Example: /usr/bin/Xalan -i 4 -p pTlsv10 "true" -p pTlsv11 "true" -o /tmp/tuningParameters5_0.xml tuningParameters5_0.xml tuningParameters500addLmiSecurity.xslt
-->

<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
<xsl:param name="pTlsv10" select="'True'"/>
<xsl:param name="pTlsv11" select="'True'"/>

<xsl:template match="tuningParameters:policy">
  <xsl:copy>
    <xsl:apply-templates select="@*|node()"/>
	<!-- Create elements if not exist -->
	<xsl:if test="not(tuningParameters:tuningParametersList[@Name = 'lmi.security.tlsv10'])">
      <xsl:element name="tuningParametersList" namespace="http://www.iss.net/cml/NetProtectModule/tuningParameters">
        <xsl:attribute name="Name">lmi.security.tlsv10</xsl:attribute>
        <xsl:attribute name="Value"><xsl:value-of select="$pTlsv10"/></xsl:attribute>
        <xsl:attribute name="Enabled">true</xsl:attribute>
        <xsl:attribute name="Description">Allow TLS v1.0 for LMI sessions.</xsl:attribute>
      </xsl:element>
	</xsl:if>
	<xsl:if test="not(tuningParameters:tuningParametersList[@Name = 'lmi.security.tlsv11'])">
      <xsl:element name="tuningParametersList" namespace="http://www.iss.net/cml/NetProtectModule/tuningParameters">
        <xsl:attribute name="Name">lmi.security.tlsv11</xsl:attribute>
        <xsl:attribute name="Value"><xsl:value-of select="$pTlsv11"/></xsl:attribute>
        <xsl:attribute name="Enabled">true</xsl:attribute>
        <xsl:attribute name="Description">Allow TLS v1.1 for LMI sessions.</xsl:attribute>
      </xsl:element>
	</xsl:if>
  </xsl:copy>
</xsl:template>

<!-- Modidy attribute if exist -->
<xsl:template match="tuningParameters:tuningParametersList[@Name = 'lmi.security.tlsv10']">
  <xsl:element name="tuningParametersList" namespace="http://www.iss.net/cml/NetProtectModule/tuningParameters">
    <xsl:copy-of select="@*[name() != 'Value']"/>
    <xsl:attribute name="Value"> <xsl:value-of select="$pTlsv10"/> </xsl:attribute>
    <xsl:apply-templates/>
  </xsl:element>
</xsl:template>

<xsl:template match="tuningParameters:tuningParametersList[@Name = 'lmi.security.tlsv11']">
  <xsl:element name="tuningParametersList" namespace="http://www.iss.net/cml/NetProtectModule/tuningParameters">
    <xsl:copy-of select="@*[name() != 'Value']"/>
    <xsl:attribute name="Value"> <xsl:value-of select="$pTlsv11"/> </xsl:attribute>
    <xsl:apply-templates/>
  </xsl:element>
</xsl:template>

<xsl:template match="@*|node()">
  <xsl:copy>
    <xsl:apply-templates select="@*|node()"/>
  </xsl:copy>
</xsl:template>

</xsl:stylesheet>