<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ude="http://www.iss.net/cml/NetProtectModule/userDefined" xmlns:base="http://www.iss.net/cml/NetProtectModule/base">

<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
<xsl:param name="pSchemaVersion" select="'5.0.0'"/>

<xsl:template match="ude:policy">
    <xsl:element name="policy" namespace="http://www.iss.net/cml/NetProtectModule/userDefined">
        <xsl:copy-of select="@*[name() != 'schema-version']"/>
        <xsl:attribute name="schema-version"> <xsl:value-of select="$pSchemaVersion"/> </xsl:attribute>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="ude:UserDefinedListElement">
    <xsl:element name="UserDefinedListElement" namespace="http://www.iss.net/cml/NetProtectModule/userDefined">
        <xsl:copy-of select="@*[name() != 'logEvidence']"/>
        <xsl:attribute name="logEvidence">
            <xsl:choose>
                <xsl:when test="@logEvidence = 'true'">
                    <xsl:value-of select="'OffendingPacket'"/>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="'None'"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:attribute>
        <xsl:attribute name="RuleId">
            <xsl:value-of select="count(preceding-sibling::*)"/>
        </xsl:attribute>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="base:quarantineResponse">
    <xsl:element name="quarantineResponse" namespace="http://www.iss.net/cml/NetProtectModule/userDefined">
        <xsl:copy-of select="@*[name() != 'percentage']"/>
        <xsl:attribute name="rateLimit">
            <xsl:variable name="vAllow" select="1048576 * .01 * (100 - @percentage)"/>
            <xsl:variable name="vAllowInt" select="$vAllow - ($vAllow mod 1)"/>
            <xsl:value-of select="$vAllowInt"/>
        </xsl:attribute>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="*">
    <xsl:element name="{name(.)}" namespace="http://www.iss.net/cml/NetProtectModule/userDefined">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

</xsl:stylesheet>

