<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:vs="http://www.iss.net/cml/NetProtectModule/virtualSensors">

<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
<xsl:param name="pSchemaVersion" select="'5.0.0'"/>

<xsl:template match="vs:policy">
    <xsl:element name="policy" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors">
        <xsl:copy-of select="@*[name() != 'schema-version']"/>
        <xsl:attribute name="schema-version"> <xsl:value-of select="$pSchemaVersion"/> </xsl:attribute>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

<xsl:template match="vs:virtualSensorElement">
    <xsl:if test="starts-with(@VSName,'WebApplicationSecurity')=false">
        <xsl:element name="virtualSensorElement" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors">
            <xsl:copy-of select="@*[name() != 'Adapter' and name() != 'SrcIPRange' and name() != 'VLanRange']"/>
            <xsl:attribute name="Interface"> <xsl:value-of select="@Adapter"/> </xsl:attribute>
            <xsl:choose>
				 <xsl:when test="translate(@Adapter, 'ANY', 'any') = 'any'">
					<xsl:attribute name="Interface"> <xsl:value-of select="'A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P'"/> </xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
				  <xsl:attribute name="Interface"> <xsl:value-of select="@Adapter"/> </xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>               
            <xsl:element name="domains" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors">
                <xsl:element name="vlans" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors">
                    <xsl:choose>
                        <xsl:when test="string-length(@VLanRange) = 0 or translate(@VLanRange, 'ANY', 'any') = 'any'">
                            <xsl:element name="Any" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:element name="List" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors">
                                <xsl:element name="VLanIdOrRange" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors">
                                    <xsl:attribute name="value"> <xsl:value-of select="@VLanRange"/> </xsl:attribute>
                                </xsl:element>
                            </xsl:element>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:element>
                <xsl:element name="ipv4Addresses" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors">
                    <xsl:choose>
                        <xsl:when test="string-length(@SrcIPRange) = 0 or translate(@SrcIPRange, 'ANY', 'any') = 'any'">
                            <xsl:element name="Any" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors"/>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:element name="List" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors">
                                <xsl:element name="ipv4IpOrRange" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors">
                                    <xsl:attribute name="value"> <xsl:value-of select="@SrcIPRange"/> </xsl:attribute>
                                </xsl:element>
                            </xsl:element>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:element>
                <xsl:element name="ipv6Addresses" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors">
					<xsl:choose>
						 <xsl:when test="string-length(@SrcIPRange) = 0 or translate(@SrcIPRange, 'ANY', 'any') = 'any'">
							<xsl:element name="Any" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors"/>						
						</xsl:when>
						<xsl:otherwise>
							<xsl:element name="None" namespace="http://www.iss.net/cml/NetProtectModule/virtualSensors"/>								
						</xsl:otherwise>
					</xsl:choose>
                </xsl:element>
            </xsl:element>
        </xsl:element>
    </xsl:if>
</xsl:template>

</xsl:stylesheet>

