<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:adpt="http://www.iss.net/cml/NetworkDefender/adapter">
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
  <xsl:param name="pSchemaVersion" select="'1.1.0'"/>
  <xsl:template match="adpt:policy">
    <xsl:element name="policy" namespace="http://www.iss.net/cml/NetworkDefender/adapter">
      <xsl:copy-of select="@*[name() != 'schema-version']"/>
      <xsl:attribute name="schema-version">
        <xsl:value-of select="$pSchemaVersion"/>
      </xsl:attribute>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>
  <xsl:template match="adpt:sensorHAMode ">
    <xsl:element name="sensorHAMode" namespace="http://www.iss.net/cml/NetworkDefender/adapter">
      <xsl:choose>
        <xsl:when test="@adapterHAMode='Stateful HA'">
          <xsl:attribute name="adapterHAMode">
            <xsl:value-of select="'Geographical HA'"/>
          </xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="adapterHAMode">
            <xsl:value-of select="@adapterHAMode"/>
          </xsl:attribute>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>
  <xsl:template match="*">
    <xsl:element name="{name(.)}" namespace="http://www.iss.net/cml/NetworkDefender/adapter">
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>
</xsl:stylesheet>
