<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:adapter="http://www.iss.net/cml/NetworkDefender/adapter">
<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

    <xsl:param name="pBuiltInPorts" select="'4'"/>
    <xsl:param name="pNmcPorts" select="'0'"/>

    <!-- Default settings for NMC cards -->
	<xsl:variable name="vCardID" select="''"/>
	<xsl:variable name="vCardName" select="''"/>
	<xsl:variable name="vPort1" select="''"/>
	<xsl:variable name="vPort1InUse" select="'true'"/>
	<xsl:variable name="vPort1KillDestination" select="'thisPort'"/>
	<xsl:variable name="vSpeedDuplexSettings1" select="'Auto'"/>
	<xsl:variable name="vPort2" select="''"/>
	<xsl:variable name="vPort2InUse" select="'true'"/>
	<xsl:variable name="vPort2KillDestination" select="'thisPort'"/>
	<xsl:variable name="vSpeedDuplexSettings2" select="'Auto'"/>
	<xsl:variable name="vUnanalyzedPolicy" select="'Forward'"/>
	<xsl:variable name="vPropagateLink" select="'Auto'"/>
	<xsl:variable name="vAdapterMode" select="'InlineProtection'"/>
	<xsl:variable name="vFailMode" select="'Auto'"/>
	<xsl:variable name="vHAPartnerCard" select="''"/>

    <!-- Root node -->
    <xsl:template match="adapter:policy">
        <xsl:copy>
            <xsl:copy-of select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>

	<xsl:template match="adapter:CardManagementList">
	    <xsl:element name="CardManagementList" namespace="http://www.iss.net/cml/NetworkDefender/adapter">
	        <xsl:copy-of select="./adapter:CardManagementParameters[@CardID &lt;= number($pBuiltInPorts) div 2]"/>
	        <xsl:if test="$pNmcPorts &gt; 0">
	            <xsl:call-template name="AddCards">
	                <xsl:with-param name="id" select="number($pBuiltInPorts) div 2 + 1" />
	                <xsl:with-param name="total" select="number($pBuiltInPorts) div 2 + number($pNmcPorts) div 2" />
	            </xsl:call-template>
	        </xsl:if>
            <xsl:copy-of select="./adapter:sensorHAMode"/>
	    </xsl:element>
	</xsl:template>
	
	<xsl:template name="AddCards">
	    <xsl:param name="id" select="1" />
	    <xsl:param name="total" select="10" />
        <xsl:variable name="vHAPartnerCard"> 
            <xsl:if test="(number($id) mod 2) = 0">
                <xsl:value-of select="number($id) -1"/>
            </xsl:if>
        </xsl:variable>
	    
	    <xsl:element name="CardManagementParameters" namespace="http://www.iss.net/cml/NetworkDefender/adapter">
	        <xsl:attribute name="CardID"> <xsl:value-of select="$id"/> </xsl:attribute>
	        <xsl:attribute name="CardName">Port<xsl:value-of select="$id"/> </xsl:attribute>
	        <xsl:attribute name="Port1"> <xsl:number value="$id*2 - 1" format="A"/> (<xsl:value-of select="$id"/>A)</xsl:attribute>
	        <xsl:attribute name="Port1InUse"> <xsl:value-of select="$vPort1InUse"/> </xsl:attribute>
	        <xsl:attribute name="Port1KillDestination"> <xsl:value-of select="$vPort1KillDestination"/> </xsl:attribute>
	        <xsl:attribute name="SpeedDuplexSettings1"> <xsl:value-of select="$vSpeedDuplexSettings1"/> </xsl:attribute>
	        <xsl:attribute name="Port2"> <xsl:number value="$id*2" format="A"/> (<xsl:value-of select="$id"/>B)</xsl:attribute>
	        <xsl:attribute name="Port2InUse"> <xsl:value-of select="$vPort2InUse"/> </xsl:attribute>
	        <xsl:attribute name="Port2KillDestination"> <xsl:value-of select="$vPort2KillDestination"/> </xsl:attribute>
	        <xsl:attribute name="SpeedDuplexSettings2"> <xsl:value-of select="$vSpeedDuplexSettings2"/> </xsl:attribute>
	        <xsl:attribute name="UnanalyzedPolicy"> <xsl:value-of select="$vUnanalyzedPolicy"/> </xsl:attribute>
	        <xsl:attribute name="PropagateLink"> <xsl:value-of select="$vPropagateLink"/> </xsl:attribute>
	        <xsl:attribute name="AdapterMode"> <xsl:value-of select="$vAdapterMode"/> </xsl:attribute>
	        <xsl:attribute name="FailMode"> <xsl:value-of select="$vFailMode"/> </xsl:attribute>
	        <xsl:attribute name="HAPartnerCard"> <xsl:value-of select="$vHAPartnerCard"/> </xsl:attribute>
	    </xsl:element>
	
	    <xsl:if test="$id &lt; $total">
	        <xsl:call-template name="AddCards">
	            <xsl:with-param name="id" select="$id + 1" />
	            <xsl:with-param name="total" select="$total" />
	        </xsl:call-template>
	    </xsl:if>
	</xsl:template>
	
</xsl:stylesheet>