<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sp="http://www.iss.net/cml/NetworkDefender/sensorProperties">

<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
<xsl:param name="pSchemaVersion" select="'1.0.0'"/>


<xsl:template name="HealthAlerts">
    <xsl:element name="HealthAlerts" namespace="http://www.iss.net/cml/NetworkDefender/alerts">
			<xsl:element name="HealthError" namespace="http://www.iss.net/cml/NetworkDefender/alerts" >
				<xsl:attribute name="enabled">false</xsl:attribute>
				<xsl:attribute name="priority">Medium</xsl:attribute>
				<xsl:attribute name="notifyConsole">false</xsl:attribute>
				<xsl:attribute name="sendSNMP">false</xsl:attribute>
				<xsl:attribute name="snmp"></xsl:attribute>
				<xsl:attribute name="sendEmail">false</xsl:attribute>
				<xsl:attribute name="email"></xsl:attribute>				
			</xsl:element>
			<xsl:element name="HealthWarning" namespace="http://www.iss.net/cml/NetworkDefender/alerts" >
				<xsl:attribute name="enabled">false</xsl:attribute>
				<xsl:attribute name="priority">Medium</xsl:attribute>
				<xsl:attribute name="notifyConsole">false</xsl:attribute>
				<xsl:attribute name="sendSNMP">false</xsl:attribute>
				<xsl:attribute name="snmp"></xsl:attribute>
				<xsl:attribute name="sendEmail">false</xsl:attribute>
				<xsl:attribute name="email"></xsl:attribute>				
			</xsl:element>	
			<xsl:element name="HealthInformative" namespace="http://www.iss.net/cml/NetworkDefender/alerts" >
				<xsl:attribute name="enabled">false</xsl:attribute>
				<xsl:attribute name="priority">Medium</xsl:attribute>
				<xsl:attribute name="notifyConsole">false</xsl:attribute>
				<xsl:attribute name="sendSNMP">false</xsl:attribute>
				<xsl:attribute name="snmp"></xsl:attribute>
				<xsl:attribute name="sendEmail">false</xsl:attribute>
				<xsl:attribute name="email"></xsl:attribute>				
			</xsl:element>
    </xsl:element>
</xsl:template>


<xsl:template match="sp:policy">
    <xsl:element name="policy" namespace="http://www.iss.net/cml/NetworkDefender/alerts">
        <xsl:copy-of select="@*[name() != 'schema-version']"/>
        <xsl:attribute name="schema-version"> <xsl:value-of select="$pSchemaVersion"/> </xsl:attribute>
        <xsl:apply-templates select="sp:Alerts"/>
		<xsl:call-template name="HealthAlerts" />
    </xsl:element>
</xsl:template>

<xsl:template match="sp:Alerts">
    <xsl:element name="SensorAlerts" namespace="http://www.iss.net/cml/NetworkDefender/alerts">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>



<xsl:template match="*">
    <xsl:element name="{name(.)}" namespace="http://www.iss.net/cml/NetworkDefender/alerts">
        <xsl:copy-of select="@*"/>
        <xsl:apply-templates/>
    </xsl:element>
</xsl:template>

</xsl:stylesheet>

