<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:snort="http://www.iss.net/cml/NetworkDefender/snort">
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
  <xsl:param name="pSchemaVersion" select="'1.1.0'"/>
  <xsl:variable name="enableLogEvidence" select="/snort:policy/snort:SnortExec/snort:CommandLine/@EnableLogging"/>

  <xsl:template match="snort:policy">
    <xsl:element name="policy" namespace="http://www.iss.net/cml/NetworkDefender/snort">
      <xsl:copy-of select="@*[name() != 'schema-version']"/>
      <xsl:attribute name="schema-version">
        <xsl:value-of select="$pSchemaVersion"/>
      </xsl:attribute>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="snort:CommandLine">
    <xsl:element name="{name(.)}" namespace="http://www.iss.net/cml/NetworkDefender/snort">
      <xsl:copy-of select="@*[name() != 'EnableLogging' and name() != 'LineBuffering']"/>
      <xsl:attribute name="reportUrl">
        <xsl:value-of select="'false'"/>
      </xsl:attribute>
    </xsl:element>
  </xsl:template>

  <xsl:template match="snort:Rule">
    <xsl:element name="{name(.)}" namespace="http://www.iss.net/cml/NetworkDefender/snort">
      <xsl:copy-of select="@*"/>
      <xsl:attribute name="logEvidence">
        <xsl:choose>
          <xsl:when test="$enableLogEvidence = 'true'">
            <xsl:value-of select="'OffendingPacket'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'None'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="*">
    <xsl:element name="{name(.)}" namespace="http://www.iss.net/cml/NetworkDefender/snort">
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>

</xsl:stylesheet>
