<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:tp="http://www.iss.net/cml/NetProtectModule/tuningParameters">
    <xsl:variable name="vLeefEnabled" select="/tp:policy/tp:tuningParametersList[@Name='crm.leef.enabled']/@Value"/>
    <xsl:variable name="vLeefLogSize" select="/tp:policy/tp:tuningParametersList[@Name='crm.leef.logsize']/@Value"/>

    <xsl:template match="tp:policy">
        <xsl:element name="policy" namespace="http://www.iss.net/cml/NetworkDefender/leef">
            <xsl:attribute name="schema-version">1.0.0</xsl:attribute>
            <xsl:element name="Config" namespace="http://www.iss.net/cml/NetworkDefender/leef">
                <xsl:element name="LocalLog" namespace="http://www.iss.net/cml/NetworkDefender/leef">
                    <xsl:choose>
                        <xsl:when test="translate($vLeefEnabled,'TRUE','true')='true'">
                            <xsl:attribute name="enabled">true</xsl:attribute>
                            <xsl:attribute name="maxSize">
                                <xsl:choose>
                                    <xsl:when test="number($vLeefLogSize)=number($vLeefLogSize)">
                                        <xsl:value-of select="number($vLeefLogSize)"/>
                                    </xsl:when>
                                    <xsl:otherwise>10</xsl:otherwise>
                                </xsl:choose>
                            </xsl:attribute>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:attribute name="enabled">false</xsl:attribute>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:element>
            </xsl:element>
        </xsl:element>
    </xsl:template>
</xsl:stylesheet>
