class IpsEventsCell < Cell::Base
  def current
    @events = last_10_attacks
  end

  def history
    @events = @opts[:events]
  end
  
  def last_10_attacks
    data = {}
    database = get_current_db  
    attach_arr = ["attach database '#{Dbmap.issues}' as Issues"]
    db = SqliteSource.initialize_database(database, false, attach_arr)
    results = SqliteSource.query_database(db, database, query)
    format_data_hash(results)
  end
  
  def get_current_db
    files = Top10.grab_files
    first_file = ''
    files.sort_by {|f| File.mtime(f).to_i}.reverse.each do |file|
      first_file = file
      break
    end
    first_file
  end
  
   def format_data_hash(data)
    fmt_data = Array.new
    data.each do |item|
      tmp = Hash.new
      item.fields.each_with_index do |f, j|
        if f == 'Occurred'
          tmp[f] = FilterDate.convert_to_local(item[j])
        else
          tmp[f] = item[j]
        end
      end
      fmt_data.push tmp
    end
    fmt_data
  end
  
  def query
    q = "select av.Occurred as Occurred, av.IssueID as IssueID, av.Priority as Priority, "
    q << "av.VulnStatus as VulnStatus, cd.CheckName as Checkname, cd.XPU as XPU, "
    q << "av.AlertName as AlertName, av.AlertType as AlertType from AttacksView av "
    q << "LEFT OUTER JOIN issues.CheckDatesView cd ON av.IssueID = cd.IssueId where "
    q << "AlertType='Attack' order by av.occurred desc limit 10"
    q    
  end
  
end
