class Dashboard::NetworkController < ApplicationController
  before_filter :load_health

  def index  
    begin
      raise ApplianceExceptions::NetworkDownException if @state.blank?
      render_method = NetworkState.get_render_method(@state)
      eval(render_method)
    rescue ApplianceExceptions::NetworkDownException
      session[:error] = true
      flash[:notice] = "There is a problem with your network. \
           Please contact support is this problem persist."
    end
    render render_method
  end


  def segment
    if @network_config_counts[:segment] == 0
      redirect_to :action => :index 
      return
    end

    begin
      raise ApplianceExceptions::NetworkDownException if @state.blank?
      @port = params[:id].nil? ? NetworkState.get_first_segment(@state) : params[:id]
      @tabdata = {:name=>"Segment", :url=>"/dashboard/network/segment", 
                :alturl => "/dashboard/network/interface"}
    rescue ApplianceExceptions::NetworkDownException
      session[:error] = true
      flash[:notice] = "There is a problem with your network. \
           Please contact support is this problem persist."
    end
  end


  def interface
    if @network_config_counts[:interface] == 0
      redirect_to :action => :index 
      return
    end

    begin
      raise ApplianceExceptions::NetworkDownException if @state.blank?
      @port = params[:id].nil? ? NetworkState.get_first_interface(@state) : params[:id]
      segment_port = Adapter.find_by_port(@port).segment.port

      @iface_state = @state[segment_port][@port]
      @tabdata = {:name=>"Interface", :url=>"/dashboard/network/interface", 
                :alturl => "/dashboard/network/segment"}
    rescue ApplianceExceptions::NetworkDownException
      session[:error] = true
      flash[:notice] = "There is a problem with your network. \
           Please contact support is this problem persist."
    end
  end

  private

  def load_health
    health = SqliteSource.new("system_health")
    @health = health.data("WHERE INDICATORID='11' AND STATE != '12'")
  end

  def tabdata
    @tabdata = [{:name => "Segment", 
                 :url => "/dashboard/network/segment",
                 :data => NetworkState.segment_stores},
                {:name => "Interface",
                 :url => "/dashboard/network/interface",
                 :data => NetworkState.interface_stores}]
  end
end
