class HaController < ApplicationController
  layout nil
  SUB_NAMESPACE = "cml/NetProtectModule/ctDBTApplyRuleString"
  VERSION = "1.0"
  NAMESPACE = "http://www.iss.net/#{SUB_NAMESPACE}"
  POLICY = "DBTApplyRuleString"
  
  protect_from_forgery :except => :dbt_apply_rules
  
  def dbt_apply_rules
    apply_policy(request.raw_post)
    render :nothing => true, :status => 200
  end
  
  def dbt_get_rules
    @policy_content = get_policy()
    if @policy_content.nil?
      render :nothing => true, :status => :service_unavailable
    else
      render :text => @policy_content
    end
  end
  
private
  def get_policy()
    Issasapache::run "-a gp -pname '#{POLICY}' -pv '#{VERSION}' -pns '#{NAMESPACE}'"
    
    src = FOLDER_CRM_POLICY + SUB_NAMESPACE + "/" + POLICY + VERSION.sub(".","_") + ".xml"
    if(File.exist?(src))
      file = File.open(src)
      file.readlines
    else
      logger.warn "Could not find file '" + src + "'"
      nil
    end
  end
  
  def apply_policy(data)
    logger.info "HaController.apply_policy"
    Issasapache::run "-a ctp -pns #{NAMESPACE} -sv #{VERSION} -pc \"#{data}\""
  end
end