class HealthController < ApplicationController

  def index
    @health = {:system => system_health, :network => network_health,
               :security => security_health, :sp => sp_health}

    respond_to do |format|
      format.xml # index.xml.builder
      format.json {render :json => @health}
    end
  end

  def system
    health = SqliteSource.new("system_health")
    @health = health.data("WHERE INDICATORID='8'")
    respond_to do |format|
      format.xml # system.xml.builder
      format.json {render :json => @health}
    end
  end

  def network
    health = SqliteSource.new("system_health")
    @health = health.data("WHERE INDICATORID='11'")

    respond_to do |format|
      format.xml # network.xml.builder
      format.json {render :json => @health}
    end
  end

  def security
    health = SqliteSource.new("system_health")
    @health = health.data("WHERE INDICATORID IN ('9','24')")

    respond_to do |format|
      format.xml # security.xml.builder
      format.json {render :json => @health}
    end
  end

  def site_protector
    health = SqliteSource.new("system_health")
    @health = health.data("WHERE INDICATORID='10'")

    respond_to do |format|
      format.xml # site_protector.xml.builder
      format.json {render :json => @health}
    end
  end
  
  private
  def system_health
    health = SqliteSource.new("system_health")
    health.data("WHERE INDICATORID='8'")  
  end
  
  def security_health
    health = SqliteSource.new("system_health")
    health.data("WHERE INDICATORID IN ('9','24')")
  end
  
  def sp_health
    health = SqliteSource.new("system_health")
    health.data("WHERE INDICATORID='10'")
  end
  
  def network_health
    health = SqliteSource.new("system_health")
    health.data("WHERE INDICATORID='11'")
  end
end