class Main::DashboardController < ApplicationController
  before_filter :load_health, :update_interface
  def index
    @vols_cache = DataSource.raw_volume_info[4]
    @raid_status = DataSource.raid_info
    @has_raid = (@raid_status.size > 0 ? true : false)
    @memused = DataSource.memory_percent_used
    @network_info = SqliteSource.new("network_info").data
    load_software_info()
  end

  def toggle_sp
    use_sp = params[:id]
    msg, err = Appliance.set_management(use_sp)
    ret = "{error_status:'#{err}', msg:'#{msg}'}"
    render :text => ret
  end

  def get_top10_graph
    @graph = params[:id]
    @link_title = link_title(params[:id])
  end

  def get_network_graph
    @graph = params[:id]
    @link_title = link_title(params[:id])
  end

  def link_title(arg)
    case arg
      when 'intruders' : "Top 10 intruders"
      when 'attacks' : "Top 10 attacks"
      when 'victims' : "Top 10 victims"
      when 'packets' : "Total packet/s"
      when 'bandwidth' : "Total Mbit/s"
    end
  end
  
  private
  
  def load_health
    @health = []
    health = SqliteSource.new("system_health")
    nodes = health.data("WHERE STATE != '12'")
    @health = Appliance.group_health_nodes(nodes)
  end
  
  def update_interface
    Lum.load_data
  end
  
  def blocked_packets
     @bp = @opts[:post]
  end

  def filters
    ["Mbit/s in", "Mbit/s out", "Mbit/s secured", "Mbit/s unanalyzed"]
  end

  def dataranges(data, fltr)
    ret = {:avg=>0, :max=>0, :min=>0}
    return ret if data.blank?

    if data.has_key?(fltr)
      begin
        arr = data[fltr].map{|v| v[1].to_f}.sort
        ret[:avg] = arr.inject(0){|sum, item| sum + item} / arr.size.to_f
      rescue
        return ret
      end
      ret[:max] = arr[-1]
      ret[:min] = arr[0]
    end
    ret
  end
end
