class PingToolController < ApplicationController
 
  def index
    
    if session[:pinger].present? and session[:pinger].instance_of?(Pinger)
      session[:pinger].destroy
      session[:pinger] = nil
    end
    
    create_pinger()
  end

  def get_ping
    results = session[:pinger].results
    
    if results[0] == "1" and session[:pinger].ipv6 == true
      RAILS_DEFAULT_LOGGER.info "[#{Time.now}] PingToolController.get_ping:  Ipv6 Ping Failed"
      if session[:pinger].ipv4 == true
        RAILS_DEFAULT_LOGGER.info "[#{Time.now}] PingToolController.get_ping:  Trying Ipv4 ping with #{session[:pinger].address}"
        results = Array.new
        session[:pinger].ipv6_fail = true
        session[:pinger].ping_ipv4(session[:pinger].address)
      end
    end
    render :partial => 'ping_output', :locals => {:results => results}
  end

  def ping
    ping_address = params['address']
    if IPv4Validator.validate(ping_address)
      @ping_address = ping_address
      session[:pinger].ping_ipv4(@ping_address)
    elsif  IPv6Validator.validate(ping_address)
      @ping_address = ping_address
      session[:pinger].ping_ipv6(@ping_address)
    elsif HostNameValidator.validate(ping_address) && ping_address !~ /^[\d\.]+$/
      @ping_address = ping_address
      session[:pinger].ping_hostname(@ping_address)
    else
      @ping_address = ping_address
      session[:pinger].ping_fail(@ping_address)
    end  
    
    render :nothing => true
  end
  
  private
  def create_pinger()
    session[:pinger] = Pinger.new
  end
end
