class Setup::DatetimeController < Setup::SetupController
  layout 'setup'
  
  
  def index
    @timezones = Timezone.all
    begin
      @timedate = TimeDate.find(:first)
      raise "" if @timedate.nil?
    rescue
      @timedate = TimeDate.new
      @timedate.ntp_version = 3
    end
  end

  def create
    @timedate = TimeDate.find(:first)

    begin
      unless @timedate.blank?
        @timedate = TimeDate.update(@timedate.id, params[:site_protector])
      else
        @timedate = TimeDate.new(params[:site_protector])
      end
    
      @timedate.current_time = TimeDate.create_time(params)
      @timedate.date = TimeDate.date(params)
      @timedate.time = TimeDate.time(params)
      @timedate.timezone = params[:timedate][:timezone] unless params[:timedate][:timezone].nil?
      @timedate.ntp_server = params[:timedate][:ntp_server].strip unless params[:timedate][:ntp_server].nil?
      @timedate.ntp_version = params[:timedate][:ntp_version] unless params[:timedate][:ntp_version].nil?
      @timedate.enable_ntp = params[:timedate][:enable_ntp] unless params[:timedate][:enable_ntp].nil? 
      @timedate.save!
      
      altnav = params[:altnav]
      if altnav.blank?
         next_page 
       else
         navigate(altnav)
       end
    rescue ActiveRecord::RecordInvalid
     @timezones = Timezone.all
      render :index
    end
  end  

  def next_page
    session[:datetime_set] = true
    redirect_to :action=>:index, :controller=>:site_protector 
  end

  def navigate(altnav)
    redirect_to :controller => "/setup/#{altnav}"
  end
  

  def show_ntpserver_dropdown
    @toggle_status = params[:id]  
  end
end
