class Setup::SiteProtectorController < Setup::SetupController
  layout "setup"
  
  def index
    @site_protector = SiteProtector.find(:first)
    @site_protector ||= SiteProtector.new
  end


  def create
    @site_protector = SiteProtector.find(:first)

    begin
      unless @site_protector.blank?
        @site_protector = SiteProtector.update(@site_protector.id, params[:site_protector])
      else
        @site_protector = SiteProtector.new(params[:site_protector])
      end
      
      @site_protector.address.strip! unless @site_protector.address.blank?
      @site_protector.proxy_address.strip! unless @site_protector.proxy_address.blank?
      
      @site_protector.save!
      
      altnav = params[:altnav]
      if altnav.blank?
         next_page 
       else
         navigate(altnav)
       end
    rescue ActiveRecord::RecordInvalid
      render :index
    end
  end

  
  def next_page
    session[:site_protector_set] = true
    redirect_to :action=>:index, :controller=>:updates
  end
  
  def navigate(altnav)
    redirect_to :controller => "/setup/#{altnav}"
  end
  
end
