class Setup::UpdatesController < Setup::SetupController
  protect_from_forgery :only=>[:upload_update]
  layout "setup"
  
  def index
    @messages = ""
    unless session[:messages].nil?
      @messages = session[:messages]
      session[:messages] = nil
    end
  end

  
  def upload_update
    session[:messages] = {}

    begin
      raise ApplianceExceptions::FileBlank if params["update"].blank?
      UpdateFile.save(params)
      Lum.find_local_updates
      session[:messages] = Lum.update
    rescue ApplianceExceptions::FileBlank
      logger.error "Rescued ApplianceException::FileBlank exception"
      session[:messages][:status_failure] = {:blank_file => "You must select a valid security content file to upload"}
    rescue ApplianceExceptions::FileTooLarge
      logger.error "Rescued ApplianceExceptions::FileTooLarge exception"
      session[:messages][:status_failure] = {:too_large => Message.new(:file_too_large, :error).text}
    rescue ApplianceExceptions::FileNotFound
      logger.error "Rescued ApplianceExceptions::FileNotFound exception"
      session[:messages][:status_failure] = {:not_found => Message.new(:file_not_found, :error).text}
    end
    
    redirect_to :action => "index"
  end
  

  def next_page
    altnav = params[:altnav]
    
    unless altnav.blank?
      navigate(altnav)
      return
    end
    
    session[:updates_set] = true
    redirect_to :action=>:index, :controller=>:completion
    return
  end

  
  def prev_page
    redirect_to :action=>:index, :controller=>:site_protector
    return
  end
  
  def navigate(altnav)
    redirect_to :controller => "/setup/#{altnav}"
  end
  
  
end
