class Setup::XforceController < Setup::SetupController
  layout "setup"
  @@security_mode_csv = "/usr/lib/iss-pam/security_modes.csv"

  def index 
    @xforce = Xforce.find(:first)
	
	@xf_mode = []
	if File.exist?(@@security_mode_csv)
	  has_check = false
	  def_select = 0
	  idx = 0
	
      File.open(@@security_mode_csv).read.split("\n").each do |line|
        value, order, default, key, desc_key = line.split(",")
        text = `cat /usr/lib/iss-pam/translations_en.xml | grep -v dtd | /usr/bin/Xalan -p pModeKey "'#{key}'" - /etc/crm/transforms/xslt/XForceSecurityName.xslt`
	    desc_text = `cat /usr/lib/iss-pam/translations_en.xml | grep -v dtd | /usr/bin/Xalan -p pModeKey "'#{desc_key}'" - /etc/crm/transforms/xslt/XForceSecurityName.xslt`
		
		text += " - " + desc_text if desc_text and desc_text.length > 0
		
		def_select = idx if (["Y","y"].include?(default))
		
		# match priority: db value > csv defined
		check = @xforce.protection_level == value ? true : false
		has_check = true if (check)
		  
	    @xf_mode << {:value => value, :order => order.to_i, :text => text,  :check => check}
		
		idx += 1
      end
	  
	  # no matched db value, use default setting
	  @xf_mode[def_select][:check] = true unless has_check
	  
	  # sort by order
	  @xf_mode.sort! { |a,b| a[:order] <=> b[:order] }
	else
	  @xf_mode << {:value => "moderate", :order => 1, :text => "Moderate", :check => true}
	end
  end  
  
  def create
    @xforce = Xforce.find(:first)

    begin
      unless @xforce.blank?
        @xforce = Xforce.update(@xforce.id, params[:xforce])
      else
        @xforce = Xforce.new(params[:xforce])
      end
            
      @xforce.save!
      altnav = params[:altnav]
      
      if altnav.blank?
        next_page 
      else
        navigate(altnav)
      end  
      
    rescue ActiveRecord::RecordInvalid
      render :index
    end
  end
  
  def next_page
    session[:xforce_set] = true
    redirect_to :action=>:index, :controller=>:security_interfaces
    return
  end 
  
  def navigate(altnav)
    redirect_to :controller => "/setup/#{altnav}"
  end
  
end
