class Statistics::Interface::PacketsController < ApplicationController
  def index
    @src = params[:id].nil? ? NetworkState.get_first_interface(@state) : params[:id]
    bandwidth = RrdSource.new("drv#{@src}")
    resolution, timespan = NetworkState.get_resolution_and_timespan(params[:history])

    respond_to do |format|
      format.xml {@data = RrdSource.filter_by_keys(bandwidth.data(3600, "24h"), filter)}
      format.json {render :json => RrdSource.filter_by_keys(bandwidth.data(resolution, timespan), filter)}
    end
  end

  def show
    check_state()
    @port = params[:id].nil? ? NetworkState.get_first_interface(@state) : params[:id]
    segment_port = Adapter.find_by_port(@port).segment.port
    @iface_state = @state[segment_port][@port]
    @tabdata = {:name=>"Interface", :url=>"/statistics/interface/packets", :alturl => "/statistics/segments/packets"}
    @history = params[:history] !~ /hour|day|week|month/ ? "hour" : params[:history]
    @href = @tabdata[:url] + "/" + @port
  end

  def packets
    bandwidth = RrdSource.new("drv")
    
    respond_to do |format|
      format.xml {@data = RrdSource.filter_by_keys(bandwidth.data(3600, "24h"), filter)}
      format.json {render :json => RrdSource.filter_by_keys(bandwidth.data, filter)}
    end
  end


  private
  def check_state
    if @network_config_counts[:interface] == 0
      redirect_to :controller => "/dashboard/network" 
      return
    end
  end

  def filter
    filter_params = ['Packets injected', 'Packets blocked']
    filter_params.concat(['Packets forwarded', 'Packets unanalyzed'])
    filter_params
  end
end
