class Statistics::IpmController < ApplicationController
  def index
    ipm = RrdSource.new("ipm")
    filter = create_filter(params)  
  
    respond_to do |format|
      format.html
      format.xml {
          if ! filter.empty?
            @data = RrdSource.filter_by_keys(ipm.data(3600, "24h"), filter)
          else
            @data = ipm.data(3600, "24h")
          end
        
      }
      format.json {
        if ! filter.empty?
          @data = RrdSource.filter_by_keys(ipm.data, filter)
        else
          @data = ipm.data
        end
        render :json => @data
        }
    end
  end
  
  def show 
  end
  
  private
  def create_filter(params)
    filter = Array.new
    params.each do |name, value|
      if name =~ /^filt[0-5]$/
        filt_name = return_valid_filter_name(value)
        if ! filt_name.nil?
          filter.push(filt_name) 
        end 
      end

    end

    filter
  end
  
  def return_valid_filter_name(name)
    if filter_options[name]
      return filter_options[name] 
    else 
      return nil
    end
  end
  
  def filter_options
    {'blocked' => 'Blocked', 'white_listed' => "White listed", 
     'medium' => 'Medium', 'high' => 'High', 'not_blocked' => 'Not blocked',
     'low' => 'Low'} 
  end
  
  def all_filters
    all_filter_options.values
  end
end
