class Statistics::Segments::PacketsController < ApplicationController
  def index
    @src = params[:id].nil? ? NetworkState.get_first_segment(@state) : params[:id]
    bandwidth = RrdSource.new("drv#{@src}")
    resolution, timespan = NetworkState.get_resolution_and_timespan(params[:history])

    respond_to do |format|
      format.xml {@data = RrdSource.filter_by_keys(bandwidth.data(3600, "24h"), filter)}
      format.json {render :json => RrdSource.filter_by_keys(bandwidth.data(resolution, timespan), filter)}
    end
  end

  def show
    check_state()
    @port = params[:id].nil? ? NetworkState.get_first_segment(@state) : params[:id]
    @tabdata = {:name=>"Segment", :url=>"/statistics/segments/packets", :alturl => "/statistics/interface/packets"}
    @history = params[:history] !~ /hour|day|week|month/ ? "hour" : params[:history]
    @href = @tabdata[:url] + "/" + @port
  end

  private
  def check_state
    if @network_config_counts[:segment] == 0
      redirect_to :controller => "/dashboard/network" 
      return
    end
  end

  def filter
    filter_params = ['Packets injected', 'Packets blocked']
    filter_params.concat(['Packets forwarded', 'Packets unanalyzed'])
    filter_params
  end
end

