# Methods added to this helper will be available to all templates in the application.
module ApplicationHelper
  include SetupHelper
  def render_help_link
    href = ""
    helpurl = ""
    if session[:currentnode].nil?
      helpurl = "/webhelp/provg_help.htm#concepts/m_vs_proventia_manager_home.htm"
    else
      helpurl = session[:currentnode].help
    end

    href = popup(helpurl)
    help_link = "<a href='#' onclick=\"#{href}\">#{'Need Help?'}</a>"
    return help_link
  end

  def local_address?(addr)
    if addr =~ /127.0.0.1/
      return true
    elsif addr =~ /0.0.0.0/
      return true
    end
  end

  def render_health_class(arg)
    css_class = "status_normal"
    
    arg.each do |mod|   
      if mod.state == "13"
        css_class = "status_warning"
      elsif mod.state == "14"      
        css_class = "status_error"
        break
      end
    end
    css_class
  end
  
  def hostname
    DataSource.hostname
  end

  def machine_type
    begin
      DataSource.machine_type
    rescue
      return "unknown"
    end
  end

  def custom_javascript_include_tag
    js_str = ""    
    session[:currentnode].javascripts.each do |js| 
      js_str << "<script type='text/javascript' src='/javascripts/#{js.name}.js'></script>" 
    end
    js_str
  end

  def custom_stylesheet_link_tag
    css_str = ""    
    session[:currentnode].stylesheets.each do |css| 
      css_str << "<link href='/stylesheets/#{css.name}.css' media='screen' rel='stylesheet' type='text/css' />\n" 
    end
    css_str
  end

  def parse_update_data(update)
    data = update.split(" - ")  
  end

  def popup(href)
    # TODO _blank target is a workaround for fubar'ed RoboHelp content.  Errors exist within the content which seem to prevent subsequent links to load...
    str = ""
    str << "window.open('#{href}', '_blank', 'toolbar=0, width=660, "
    str << "height=600, menubar=1, scrollbars=1, resizable=1');"
    str
  end
end
