class AlertLogDb
  attr_reader :start_date, :end_date, :zoom_start_date, :zoom_end_date

  def initialize(filter,live_view=0)
    @filter=filter
    @live_view = live_view
  end

  def find_current(result_size, zoom_result_size)
    @cache = cache.new(@filter, result_size, @live_view)
    @cache.page_begin
  end

  def find_newer
    @cache.page_newer
  end

  def find_older
    @cache.page_older
  end

  def find_oldest
    @cache.page_end
  end

  def find_newest
    @cache.page_begin
  end  

  def at_oldest?
    @cache.at_end?
  end

  def at_newest?
    @cache.at_begin?
  end

  def first_index
    @cache.start_index_on_page
  end
  
  def last_index
    @cache.end_index_on_page
  end

  def has_filter?
    !@cache.filter.empty?
  end

  protected
  def cache
    AlertLogCache
  end

end
