class Link < ActiveRecord::Base
  acts_as_tree
  has_one :cpe_property
  has_and_belongs_to_many :javascripts
  has_and_belongs_to_many :stylesheets

  def self.root_nodes
    find(:all, :conditions=> {:parent_id=>nil, :nav_item => true})  
  end

  def self.filtered(node, admin)
    nodes = node.children
    nodes = nodes.map{ |n| n if (!n.admin || n.cpe) } unless admin
    nodes.compact!
    nodes = nodes.map{ |n| n if n.nav_item }
    nodes.compact!
    nodes
  end
end
