class StatusEntry < ActiveRecord::Base
  has_many :updates
  
  def self.get_module_name(module_name)
    case module_name
      when "sslvpn_module" : "SSL VPN"
      when "antivirus_module" : "Antivirus"
      when "intrusion_prevention_module" : "Intrusion Prevention"
      when "spam_module" : "Antispam"
      when "filter_module" : "Web Filter"
      else "Firmware"
    end
  end
  
  def self.firmware_versions
    major_versions = []
    u = Update.find_all_by_name("Firmware")

    u.each do |f|
      major_versions << f.major_release_version    
    end

    major_versions.uniq!
    major_versions
  end
  
  def self.get_series_updates(entry)
    updates = []
    entry.updates.each{|e| updates << e if entry.major_release_version == e.major_release_version}
    updates = entry.updates if updates.empty?
    updates
  end
end
