class Traceroute < Tool

  attr_reader :ipv6, :ipv4, :address
  attr_accessor :ipv6_fail
  
  def initialize()
    @ipv6 = false
    @ipv4 = false
    @ipv6_fail = false
    super(TRACEROUTE)   
  end

  def results
    results = super
    if @ipv6_fail and @ipv4
      results.unshift "Tried IPv6 traceroute but it failed.  Trying IPv4 traceroute..."
      results.unshift " "
    end
    
    results
  end
    
  def trace_ipv4(target)
    @ipv4 = true
    @address = target
    execute("#{target}")
  end
  
  def trace_ipv6(target)
    @ipv6 = true
    @address = target
    execute("#{target}",@tool+"6")
  end
  
  def trace_hostname(target)
    @ipv6 = false
    @ipv4 = false
    @address = target
    addresses = HostInfo.find_address_by_name(target)
    addresses.each do |ip|
      break if @ipv6 and @ipv4
      if IPv6Validator.validate(ip)
        @ipv6 = true
      elsif IPv4Validator.validate(ip)
        @ipv4 = true
      end
    end
    
    if @ipv6
      trace_ipv6(target)
    elsif @ipv4
      trace_ipv4(target)
    end      
  end
  
  def trace_fail(target)
    fail_msg("Traceroute Failed: The target '#{target}' is invalid.")
  end
end
