  include LmiValidators

ActiveRecord::Base.class_eval do
  def self.validates_ipv6(*attrs)
    options = attrs.last.is_a?(Hash) ? attrs.pop.symbolize_keys : {} 

    validates_each(attrs) do |record, attr_name, value|    
      unless value.blank? and options[:allow_nil]    
        unless (options[:if] && !record.send(options[:if].to_s)) || 
          (options[:unless] && record.send(options[:if].to_s)) 
          match = IPv6Validator.validate(value)
          record.errors.add(attr_name, "is invalid") unless match
        end
      end
    end
  end

  def self.validates_ipv4(*attrs)
    options = attrs.last.is_a?(Hash) ? attrs.pop.symbolize_keys : {} 

    validates_each(attrs) do |record, attr_name, value|
      unless value.blank? and options[:allow_nil]    
        unless (options[:if] && !record.send(options[:if].to_s)) || 
          (options[:unless] && record.send(options[:unless].to_s)) 
          match = IPv4Validator.validate(value)
          record.errors.add(attr_name, "is invalid") unless match
        end
      end
    end
  end

  def self.validates_hostname(*attrs)
    options = attrs.last.is_a?(Hash) ? attrs.pop.symbolize_keys : {} 

    validates_each(attrs) do |record, attr_name, value|
      unless value.blank? and options[:allow_nil]    
        unless (options[:if] && !record.send(options[:if].to_s)) || 
          (options[:unless] && record.send(options[:if].to_s)) 
          match = HostNameValidator.validate(value)
          record.errors.add(attr_name, "is invalid") unless match
        end
      end
    end
  end

  def self.validates_short_hostname(*attrs)
    options = attrs.last.is_a?(Hash) ? attrs.pop.symbolize_keys : {} 

    validates_each(attrs) do |record, attr_name, value|
      unless value.blank? and options[:allow_nil]    
        unless (options[:if] && !record.send(options[:if].to_s)) || 
          (options[:unless] && record.send(options[:if].to_s)) 
          match = ShortHostNameValidator.validate(value)
          record.errors.add(attr_name, "is invalid") unless match
        end
      end
    end
  end

  def self.validates_net_address(*attrs)
    options = attrs.last.is_a?(Hash) ? attrs.pop.symbolize_keys : {} 

    validates_each(attrs) do |record, attr_name, value|
      unless value.blank? and options[:allow_nil]    
        unless (options[:if] && !record.send(options[:if].to_s)) ||  
          (options[:unless] && record.send(options[:if].to_s)) 

          match = NetAddressValidator.validate(value)
          
          record.errors.add(attr_name, "is not a valid IPv4, IPv6 or domain name") unless match
        end
      end
    end
  end

def self.validates_ip_address(*attrs)
    options = attrs.last.is_a?(Hash) ? attrs.pop.symbolize_keys : {} 

    validates_each(attrs) do |record, attr_name, value|
      unless value.blank? and options[:allow_nil]    
        unless (options[:if] && !record.send(options[:if].to_s)) ||  
          (options[:unless] && record.send(options[:if].to_s)) 

          match = IPv4Validator.validate(value) unless match
          match = IPv6Validator.validate(value) unless match
          
          record.errors.add(attr_name, "is not a valid IPv4, IPv6 or domain name") unless match
        end
      end
    end
  end

end

