class CreateManagementInterfaces < ActiveRecord::Migration
  def self.up
    create_table :management_interfaces do |t|    

      #General Network Settings
      t.string :host_name
      t.string :sensor_name
      t.boolean :multicast_disabled
      t.boolean :is_static_dns

      #IPv4 Settings
      #0 Static, 1 DHCP
      t.integer :ipv4_addressing_method, :limit=>1, :null=>false  # 0 Automatic, 1 Manual
      t.string  :ipv4_address
      t.string  :ipv4_gateway
      t.string  :ipv4_netmask
  
      #IPv6 Settings
      t.integer :ipv6_addressing_method, :limit=>1, :null=>false # 0 Automatic, 1 Manual
      t.string  :ipv6_address
      t.string  :ipv6_prefix_length
      t.string  :ipv6_gateway

      #DNS settings
      t.string :primary_dns
      t.string :secondary_dns
      t.string :tertiary_dns
      t.string :dns_search_path
    end
  end

  def self.down
    drop_table :management_interfaces
  end
end
