class HistorySync

  def self.load_db
    file = "#{ROOTDIR}etc/lum/update-history.yaml"
    
    if (File.exists?(file))
      begin
        RAILS_DEFAULT_LOGGER.info "Opening and parsing update-history.yaml"
        history = YAML::load(File.read(file))
        insert(history) unless history == false
      rescue
        RAILS_DEFAULT_LOGGER.info "ERROR while parsing update-history.yaml"
      end
    end
  end
 
  private
  def self.insert(history)
    RAILS_DEFAULT_LOGGER.info "Loading data into the update_history table."
    UpdateHistory.delete_all
    
    history.each do |k, v| 
      RAILS_DEFAULT_LOGGER.info "Loading data into the status_entries for module #{v['name']}."
      # strip path out of log_file
      if v['log_file'] != nil
          v['log_file'] = v['log_file'].split("/")[-1]
      end
      record = UpdateHistory.new(v).save!
    end
  end
end
