class Message
  attr_accessor :text

  def initialize(sym, status=:success)
    @text = Message.get_message(sym)
  end

  def self.get_message(param)
    case param
      when :low : return 'Low'
      when :hide_time_filter_tag : return 'Hide Time Filter'
      when :time_filter_tag : return 'Time Filter'
      when :show_filter_tag : return 'Show Filter'
      when :hide_filter_tag : return 'Hide Filter'
      when :stop_live_view_tag : return 'Stop Live View'
      when :live_view_tag : return 'Live View'
      when :hide_legend_tag : return 'Hide Legend'
      when :show_legend_tag : return 'Show Legend'
      when :close_upload_form_tag : return 'Close Upload Form'
      when :upload_form_tag : return 'Upload Update File'
      when :close_upload_license_tag : return 'Close Upload Form'
      when :upload_license_tag  : return 'Upload License Key'
      when :missing_save_filter_tag  
        return 'You must enter a filter tag name before saving a filter.'
      when :missing_filter_criteria 
        return 'You must provide filter criteria.'
      when :missing_update_file 
        return 'You must supply an update file to install.'
      when :missing_license_file 
        return 'You must supply a license file to install.'
      when :firmware_install_msg
        msg = "Continuing will install new firmware which may take "
        msg += "your appliance offline for serveral minutes."        
        return msg
      when :upload_success
        return "Update file was successfully uploaded"
      when :license_upload_success
        return "License file was successfully uploaded"
      when :file_too_large 
        msg = "Insufficent disk space to upload the file.  "
        msg += "Free up disk space and try again."        
        return msg
      when :file_ext_invalid
        msg = "Invalid update file.  Check to ensure you are attempting "
        msg += "to install a valid update package."        
        return msg
      when :file_not_found 
        return "File not found or file empty.  Check the file name and try again."
      when :first_time_load 
        msg = "This appliance has never retrieved entitlements and is not "
        msg += "currently entitled to downloads. Click \"Check for updates\" "
        msg += "to aquire entitlements."        
        return msg
      when :lum_message
        return Lum.message
    end
  end

  def self.get_label(param)
    case param
      when :medium : return 'Medium'
      when :high : return 'High'
      when :notblocked : return 'Not blocked'
      when :blocked : return 'Blocked'
      when :whitelisted : return 'White listed'
      when :root : return 'Root (/)'
      when :boot : return 'Boot (/boot)'
      when :restore : return 'Restore (/restore)'
      when :rboot : return 'Rboot (/rboot)'
      when :cache : return 'Cache (/cache)'
      when :low : return 'Low'
      when :adapterpacketsre : return 'Packets in'
      when :adapterpacketstr : return 'Packets out'
      when :adapterpacketsfo : return 'Packets forwarded'
      when :adapterpacketsdr : return 'Packets blocked'
      when :adapterpacketsin : return 'Packets injected'
      when :adapterpacketsun : return 'Packets unanalyzed'
      when :adapterbytesre : return 'Mbit/s in'
      when :adapterbytestr : return 'Mbit/s out'
      when :adapterbytessr : return 'Mbit/s secured'
      when :adapterbytesus : return 'Mbit/s unanalyzed'
      when :memoryused : return 'Memory used'
    end
  end
end
