var initialPolicy=null;
var curNamespace=null;
var curPolicy=null;
var curTabloc=null;
var curReadonly=null;
var show_policy_after_prime=false;
var url_base = null;
var POLICIES_PATH = "/policies/";

var shouldConfirm = false;
window.onbeforeunload = function() {
    if(shouldConfirm) {
      return "This page contains modified settings that have not been applied to the appliance and will be lost if you continue.";
    }
}

function cpe_applet(){
  return document.getElementById("CpeControllerApplet");
}

function urlBase() {
  return(url_base);
}

function policyUrl(policy){
  return(urlBase() + POLICIES_PATH + policy);
}

function isSessionValid(){
 $.ajax(
  {
    url: "/sessions/valid",
    type: "get",
    success: 
      function(res)
      {
        if(res == "false"){
          document.location="/sessions";
        }
      }
  });
}

function resetNetworkSessions(){
		document.location = document.location;
}

function save_policies(){
  isSessionValid();
  var applet = cpe_applet();
  if(applet) {
    if(applet.validatePolicies()) {
      applet.savePolicies();
      shouldConfirm = false;
    } else {
      alert("One or more policies are invalid and can not be applied. Please correct all errors before applying.");
    }
  }
}

function saveComplete(cpe_message){
  message = String(cpe_message);
  if(message!="OK") {
		alert(message);
  } else if (document.location.pathname.match(/siteprotector_management$/)) {
    document.location = document.location;
  } else if(document.location.pathname.match(/security_interfaces$/)) {
		resetNetworkSessions();	
	} else {
    refresh_policy($('input:hidden[name=id]').val());
  }
}

function initApplet(urlbase) {
  url_base = urlbase;
}

function initPolicy(namespace, policy, tabloc, readonly) {
  initialPolicy=policy;
  persitsPolicyDetails(namespace, policy, tabloc, readonly);
}

function persitsPolicyDetails(namespace, policy, tabloc, readonly) {
  curNamespace=namespace;
  curPolicy=policy;
  curTabloc=tabloc;
  curReadonly=readonly;
}

function primePolicy(namespace, policy, tabloc, readonly) {
	show_policy_after_prime=false;
  cpe_primePolicy(namespace, policy, tabloc, readonly);
}

function renderPolicy(namespace, policy, tabloc, readonly) {
	show_policy_after_prime=true;
  cpe_primePolicy(namespace, policy, tabloc, readonly);
}

function cpe_primePolicy(namespace, policy, tabloc, readonly_string) {
  persitsPolicyDetails(namespace, policy, tabloc, readonly_string);
  var policy_url = policyUrl(policy);
  var readonly_boolean = is_true(readonly_string);
  cpe_applet().primePolicy(namespace, policy_url, tabloc, readonly_boolean);
}

function is_true(some_string) {
  if( some_string == null) return false;
  return(some_string.toLowerCase() == 'true');
}

function showPolicy(namespace) {
	curNamespace=namespace;
	cpe_applet().showPolicy( namespace );
}


function primeComplete(){
  if( show_policy_after_prime == true )
    showPolicy(curNamespace);
  show_save_icon();
}

function appletStarted() {
  if(initialPolicy != null) {
    renderPolicy(curNamespace, curPolicy, curTabloc, curReadonly);
    initialPolicy = null;
  }
}

function policyChanged(namespace){
  show_save_icon();
}

function show_save_icon(){
  var applet = cpe_applet();
  var has_changes = applet.hasUnsavedChanges();
  if( has_changes ) {
    shouldConfirm = true;
    $("#settings_apply").removeAttr("disabled");
    $("#settings_reset").removeAttr("disabled");
  } else {
    $("#settings_apply").attr("disabled","disabled");
    $("#settings_reset").attr("disabled","disabled");
  }
}

function refresh_policy(id){
  $.ajax({
    complete: refresh_policy_applet, 
    data: {"id":id},
    url: "/settings/refresh_policy"
    });
}

function refresh_policy_applet(XMLHttpRequest, textStatus){
  var policy_url = policyUrl(curPolicy);
  var readonly_boolean = is_true(curReadonly);
  cpe_applet().rollbackPolicy(curNamespace, policy_url, curTabloc, readonly_boolean);
}

function reset_policies(){
  isSessionValid();
  cpe_applet().rollback();
}

function rollbackPolicyComplete(){
  handle_rollback_complete();
}

function rollbackComplete(){
  handle_rollback_complete();
}

function handle_rollback_complete(){
  cpe_applet().showNoPolicy();
  renderPolicy(curNamespace, curPolicy, curTabloc, curReadonly);
}
