"use strict";

var getFilterData = function(){

  var filter_data = {}; 
  var select_id = "";
  var fselect = "";
  
  filter_data.time_select = $("#time_select").val();
  filter_data.filter_tag = $("#save_tag_tb").val();
  
  $(".filter_criteria").each(function(){
      select_id = $(this).attr("id").replace(/text/, 'coltype');
      fselect = $(this).attr("name").replace(/text/, 'coltype');

    if($(this).attr("value") !== "" && $(this).val() !== ""){
      filter_data[fselect] = $("#"+select_id).val();
      filter_data[$(this).attr("name")] = $(this).val();
    }
  });
  

  if(validStartTime()){filter_data['date[start_time]']= getStartTime();}
  if(validEndTime()){filter_data['date[end_time]'] = getEndTime();}

  return filter_data;
}

var toggleSection = function(arg, elm){
  var display = $("#alert-details-"+arg).css("display");

  if($(elm).hasClass("hide_link")){
    $("#alert-details-"+arg).hide();
    $(elm).attr("class", "expand_collapse show_link");
  }else{
    $(elm).attr("class", "expand_collapse hide_link");
    $("#alert-details-"+arg).show();
  }
};


var openHostNameLookupPanel = function(){
  $.ajax({
    url: "/alert_logs/lookup_host_name",
    type: "get",
    data: {"address": document.contextvalue},
    success: function(res){
      $("#host_info_ip").html(document.contextvalue);
      $("#host_info_name").html(res);
    }
  });
  $("#host_info").css({"left":document.clickpos.left, "top":document.clickpos.top}).fadeIn("slow");
}

var closeHostNameLookupPanel = function(){
  $("#host_info").fadeOut("slow");
  $("#host_info_ip").html("");
  $("#host_info_name").html("");
}

/*
  Submit Filter
*/
var submitFilter = function(){
  clearError();
  var filter_data = getFilterData(); 
	var $dialog = showPolling();
	
  $("#syslog").load("/alert_logs/load_filter?"+$.param(filter_data), function(){
		hidePolling($dialog);
	});
  $("#show_save_filter_button").fadeIn("slow");
};

/*
  End Submit Filter
*/


/*
  Save Filter
*/
var saveFilter = function(){
  clearError();
  var filter_data = {}; 
  var num_filters = $(".filter_criteria").length;

  if($("#save_tag_tb").attr("value") == ""){
    raiseError('missing_save_filter_tag');
    return false;
  }

  $("#save_filter_link_span").fadeIn("slow");
  

  filter_data.time_select = $("#time_select").val();
  filter_data.filter_tag = $("#save_tag_tb").val();
  filter_data.type = logFilter().type;
  
  $(".filter_criteria").each(function(){
    var select_id = $(this).attr("id").replace(/text/, 'coltype');
    var fselect = $(this).attr("name").replace(/text/, 'coltype');


    if($(this).attr("value") != ""){
      filter_data[fselect] = $("#"+select_id).val();
      filter_data[$(this).attr("name")] = $(this).val();
    }
  });
  

  if(validStartTime()){filter_data['date[start_time]']= getStartTime();}
  if(validEndTime()){filter_data['date[end_time]'] = getEndTime();}
  
  $.ajax({
    url: "/lmi_filters",
    type: "post",
    data: filter_data,
    success: function(res){
      $("#system_message").html(res).css({"display":"inline-block"});
      $("#manage_saved_filters").load("/alert_logs/manage_filters"); 
    }
  });
};


var checkKey = function(e){
  if(!e){e = window.event;}
  
  if (e.keyCode){code = e.keyCode;}
  else if(e.which){code = e.which;}
  
  if(code == 13){ 
    if(document.save_focus){saveFilter("alert");}
    else{submitFilter();}
  } 
};

var openBlockPanel = function(){
  $("#block-duration").css({"left":document.clickpos.left, "top":document.clickpos.top}).fadeIn("slow"); 
};


var confirmBlock = function(){
  document.token = $("[name=authenticity_token]").val();
  document.duration = $("[name=block-duration]:checked").val();
  $("#block-address").html(document.srcip);
  $("#duration").html("one "+document.duration);

  $("#block-duration").fadeOut("slow", function(){
    $("#block-confirm").css({"left":document.clickpos.left-10, "top":document.clickpos.top+40}).fadeIn("slow");
  });   
};


var blockEvent = function(){
  var details = {};
  $("#block-confirm").fadeOut("slow", function(){
      $("#block-wait-address").html(document.srcip);
    $("#block-wait").css({"left":document.clickpos.left-120, 
      "top":document.clickpos.top+90}).fadeIn("slow", function(){
      details["event[srcip]"] = document.srcip;
      details["event[vlanid]"] = document.vlanid;
      details["event[duration]"] = document.duration;
      details["authenticity_token"] = document.token;
      
      $.post("/events/", details, function(){
        document.location = document.location;
      });
    });  
  });  
};


var getContextMenu = function(type){
  var mtype;
  switch(type){
    case "risk" : mtype = "#risk-menu"; break;
    case "event_name" : mtype = "#event-menu"; break;
    case "issueid" : mtype = "#event-menu"; break;
    case "source-ip" : mtype = "#ip-menu"; break;
    case "source-port" : mtype = "#port-menu"; break;
    case "target-ip" : mtype = "#ip-menu"; break;
    case "target-port" : mtype = "#port-menu"; break;
    case "protocoltype" : mtype = "#protocol-menu"; break;
    case "status" : mtype = "#status-menu"; break;
    case "protection-domain" : mtype = "#protection-domain-menu"; break;
  }
  return mtype;
};




var showMenu = function(element, srcip, vlanid, issueid, alert_type){
  document.clickpos = $(element).position();
  var type = $(element).attr("rev");
  var menu = getContextMenu(type);
  document.srcip = srcip;
  document.vlanid = vlanid;
  document.issueid = issueid;
  document.contexttype = type.replace(/-/, "_");

	var elmid = $(element).attr("id");
	document.contextvalue = $("#"+elmid).data("field-val");
	
  $(menu).css("left", document.clickpos.left-1);
  $(menu).css("top", (document.clickpos.top+0));

	if(localAddress(srcip)){
		$(".block-link").css({"display":"none"});
	}else{
		$(".block-link").css({"display":"block"});
	}
	
	if(alert_type !== "Attack"){
		$(".xforce-link").css({"display":"none"});
	}else{
		$(".xforce-link").css({"display":"block"});
	}
	
  $(menu).show();
  $(menu).children(".actions").slideDown();
};

var localAddress = function(addr){
	var data = "";
	var result = false;
	
	if(addr === "127.0.0.1"){
		result =  true;
	}else if(addr === "0.0.0.0"){
		result = true;
	}else{
	  $.ajax({
	    url: "/alert_logs/ip_addr",
	    type: "get",
			async: false,
	    success: function(res){
	      data = eval( "(" + res + ")" );
				if(data["ipv4"] === addr){
					result = true;
				}else if(data["ipv6"] === addr){
					result = true;
				}
	    }
	  });
	}
	return result;
}

var loadLiveView = function(arg){
   var filter_data = getFilterData();
   var path = logFilter().path;
  $("#syslog").load("/"+path+"/refresh?"+$.param(filter_data));
};


var startLiveView = function(){
  $("#time_filter_link").hide();
  $("#timecol").hide();
  if(!document.live_view_interval){document.live_view_interval = setInterval("loadLiveView()", 6000);}
};


var stopLiveView = function(){
  clearInterval(document.live_view_interval);
  $("#time_filter_link").show();
  document.live_view_interval = undefined;
  var filter_data = getFilterData();
  var path = logFilter().path;

  document.location = "/"+path+"?"+$.param(filter_data);
};

var createSelect = function(obj){
  var select = $(document.createElement('select'));
  var option;

  select.attr("name", obj.html_name);
  select.attr("id", obj.id);
  select.change(obj.onchange);
  select.attr("class", obj.klass);
  
  for(var i=0; i < obj.options.length; i++){
    option = $(document.createElement('option'));

    if(obj.options[i][0] === obj.selected){
      option.attr("selected", "selected");
    }
    option.attr("value", obj.options[i][0]);
    option.html(obj.options[i][1]);
    select.append(option);
  }  

  return select;
};


var createFilterTextBox = function(object, id){
  var input = $(document.createElement('input'));
  input.attr("class", "filter_criteria filter-value-text");
  input.attr("id", "filter_criteria_"+id+"_text");
  input.attr("name", "filter[criteria_"+id+"][text]");
  input.attr("value", object.text);
  input.attr("size", "20");
  input.attr("type", "text");
  return input;
};


var createStatusMenu = function(object, id){
  var obj = {options : [["Detected","<img src=\"/images/icn_attackDetected_16.png\"> Detected"], ["Blocked", "<img src=\"/images/icn_attackBlocked_16.png\"> Blocked"],["Quarantined","<img src=\"/images/icn_attackQuarantine_16.png\"> Quarantined"], ["Simulated Block", "<img src=\"/images/icn_attackSimBlock_16.png\"> Simulated Block"]], "id" : "filter_criteria_"+id+"_text", klass : "filter_criteria filter-value-select", html_name : "filter[criteria_"+id+"][text]", selected : object.text};
  return createSelect(obj);
};


var createRiskMenu = function(object, id){
  var obj = {options : [["High", "<img src=\"/images/icn_riskHigh_16.png\"> High"], ["Medium", "<img src=\"/images/icn_riskMed_16.png\"> Medium"], ["Low", "<img src=\"/images/icn_riskLow_16.png\"> Low"]], "id" : "filter_criteria_"+id+"_text", klass : "filter_criteria filter-value-select", html_name : "filter[criteria_"+id+"][text]", selected : object.text};
  return createSelect(obj);
};


var createEventTypeMenu = function(object, id){
  var obj = {options : [["Attack", "Attack"], ["Audit", "Audit"], ["OpenSignature", "Open Signature"], ["Connection", "Connection"], ["User Defined", "User Defined"], ["SNORT", "SNORT"]], "id" : "filter_criteria_"+id+"_text", klass : "filter_criteria filter-value-select", html_name : "filter[criteria_"+id+"][text]", selected : object.text};
  return createSelect(obj);
};


var createFilterTypeMenu = function(object, id){
  var obj = {options : [['event_name', 'Event Name'], ['event_type', 'Event Type'], ['issueid', 'IssueID'], ['source_ip', 'Source IP'], ['source_port', 'Source Port'], ['target_ip', 'Target IP'], ['target_port', 'Target Port'], ['protocoltype', 'Protocol'], ['protection_domain', 'Protection Domain'],['vlanid', 'VlanID'], ['status', 'Status'],['risk', 'Severity']], "id" : "filter_criteria_"+id+"_coltype", klass : "filter_criteria filter_criteria_select", html_name : "filter[criteria_"+id+"][coltype]", onchange : checkType, selected : object.coltype};
  return createSelect(obj);
};


var createWrapperSpan = function(){
  var elm = $(document.createElement('span'));
  elm.attr("id", "filter_input_type_"+filterRows().next);  
  return elm;
};

var buildDateFilters = function(qs){
  var start_param = qs.get("date[start_time]");
  var end_param = qs.get("date[end_time]");
	
	if(start_param != undefined || end_param != undefined){
		$("#timecol").fadeIn();
	}

  if(start_param !== undefined){
    var start_time = new Date(parseInt(start_param, 10));
    $("#start_time").attr("value", start_time.format("mm/dd/yyyy"));
    $("#date_start_time_4i").attr("value", start_time.format("HH"));
    $("#date_start_time_5i").attr("value", start_time.format("MM"));
  }
  
  if(end_param !== undefined){
    var end_time = new Date(parseInt(end_param, 10));
    $("#end_time").attr("value", end_time.format("mm/dd/yyyy"));
    $("#date_end_time_4i").attr("value", end_time.format("HH"));
    $("#date_end_time_5i").attr("value", end_time.format("MM"));
  }
};

var addTimeSelect = function(val){
	$("#time_select").val(val);
};

var createFilterListItem = function(){
  var elm = $(document.createElement('li'));
  elm.attr("class", "filter_li");
  elm.attr("id", "li_"+filterRows().next);
  return elm;
};


var createCriteriaInput = function(object, id){
  switch(object.coltype){
    case "risk":
      return createRiskMenu(object, id);
    case "status":
      return createStatusMenu(object, id);
    case "event_type":
      return createEventTypeMenu(object, id);
    default:
      return createFilterTextBox(object, id);
  }
};


var checkType = function(){
  var object = {};  
  var id = filterRows().current;
  var elm_id = $(this).parent().attr("id").replace(/li_/, "#filter_input_type_");
  
  object.coltype = $(this).val();
  $(elm_id).html(createCriteriaInput(object, id));
}; 


var createRow = function(object){
  var id = filterRows().next;
  if(object === undefined){object = {"text": ""};}
  var li = createFilterListItem();
  var wrapper = createWrapperSpan(id);  
  li.append(createFilterTypeMenu(object, id));
  wrapper.append(createCriteriaInput(object, id));
  li.append(wrapper);
  li.append(createAddRemoveLinks("add"));
  li.append(createAddRemoveLinks("del")); 
  $("#criteria_table ul").append(li);
  $("#criteria_table ul li").fadeIn("slow"); 
  return li;
};

var buildFilterList = function(qs){
	$(".filter_li").remove();
		var has_string_filter = false;
		var criteria = [];
		var dates = {};
		var filterobj = {};

	  for(var i=0; i < qs.size; i++){   
			var obj = {}; 
	    if(qs.keys[i].search(/coltype/) != -1){
				has_string_filter = true;
				obj["coltype"] = qs.get(qs.keys[i]);
				obj["text"] = qs.get(qs.keys[i].replace(/coltype/, "text"));
				obj["id"] = qs.keys[i];
				criteria.push(obj);
			}	
		}
		
		buildDateFilters(qs);
		addTimeSelect(qs.get("time_select"));
		filterobj.criteria = criteria;
		filterobj.dates = dates;
		if(!has_string_filter){createRow(0);}
		
		$.each(filterobj.criteria, function(){createRow(this);});	
};

var loadFilter = function(id, qs){
	var $dialog =showPolling();
	
	$("#timecol").hide();
  $(".load-filter-tag").removeClass("load-filter-tag-filtered");
  $("#load-filter-tag"+id).addClass("load-filter-tag-filtered");

  clearError();
  qs = new Querystring(qs);
  $("#syslog").load("/alert_logs/load_saved_filter?id="+id, function(){
		hidePolling($dialog);
	});

  $("#save_filter_link_span").fadeIn();
  $("#pagination_links").load("/alert_logs/get_pagination?page_num=1&filter_displayed="+getFilterDisplayed());
  buildFilterList(qs);
};

var loadLinkFilter = function(arg){
  var qs = new Querystring(arg);
	var $dialog = $("<div><p>Loading filter.  Please wait...</p></div>").dialog(
								{
									autoOpen:true, 
									show:'puff', 
									hide:'puff', 
									modal: true, 
									position: "center",
									resizable: false,
									draggable: false,
									dialogClass: "alert-loading-modal"
								});

  $("#syslog").load("/alert_logs/load_filter?"+qs.query_string, function(){
		$dialog.dialog("close");
	});
  $("#pagination_links").load("/alert_logs/get_pagination?page_num=1&filter_displayed="+getFilterDisplayed());
  buildFilterList(qs);
}

var clearAlertsConfirm = function(){
  $("#clear_alerts").fadeOut("normal", function(){
    $("#clear_confirm").fadeIn();
  });
};

var clearAlertsConfirmed = function(){
  window.location = "/alert_logs/clear_alerts"
};


var clearAlertsCanceled = function(id){
  $("#clear_confirm").fadeOut("normal", function(){
    $("#clear_alerts").fadeIn();
  });
};

var determine_btn_state = function(btn,streaming) {
  if ($("#"+btn).hasClass("btn") && streaming == "true") {
    $("#"+btn).removeClass("btn");
    $("#"+btn).addClass("inactive");
  }
};

var streamButton = function(){
  var is_streaming = $("#stream-link").data("streaming");
  if(is_streaming === "false" || typeof(is_streaming) == "undefined"){
    $("#stream-link").data("streaming", "true");
    determine_btn_state("newest_btn","true")
    determine_btn_state("newer_btn","true")
    determine_btn_state("oldest_btn","true")
    determine_btn_state("older_btn","true")
    $("#time_filter").fadeOut();
    $("#time_filter_stream").fadeIn();
    startLiveView();
    $("#stream-widget").css({"background-image": "url(/images/small_ajax_loader.gif)"});
    $(this).html("<span><span>Stop Stream</span></span>");
  }else{
    stopLiveView();
    $("#stream-widget").css({"background-image": "none"});
    $("#stream-link").data("streaming", "false");
    $(this).html("<span><span>Stream Live Data</span></span>");
  }
};

$(document).ready(function(){
  var qs = new Querystring();

  if (qs.contains_filter_data) {
    buildFilterList(qs);
  } else {
    createRow(0);
  }
    
  registerListeners();
  filterTimeRange();
  
  $('#clear_alerts').click(clearAlertsConfirm);
  $('#clear_confirmed').click(clearAlertsConfirmed);
  $('#clear_canceled').click(clearAlertsCanceled);
  $("#reset_filter_link").click(clearFilter);

  $("#start_time").datepicker(); 
  $("#end_time").datepicker();

  $("#stream-link").click(streamButton);

  $("#show_save_filter_button").click(function()
    {$("#save_filter_div").fadeIn("slow");
   });

  $(".cancel-block-link").click(function(){
    $("#block-duration").fadeOut("slow");
    $("#block-confirm").fadeOut("slow");
  });

  $("#close_save_filter_link").click(function(){
    clearError();
    $("#save_filter_div").fadeOut("slow");
  });
   
  $(".context-menu").hover(function(){}, 
    function(){ 
      var menu = $(this);
      menu.children(".actions").slideUp();
      menu.hide();
   });


  $(".filter-link").click(
    function(){
      cleanRows();

      var ftype = document.contexttype;  
			$("#show_save_filter_button").fadeIn("slow");
      var val = document.contextvalue;

			if( ftype == "risk" ) {
        	switch(val){
          	case "<img src=\"/images/icn_riskLow_16.png\">" : val="Low"; break;
          	case "<img src=\"/images/icn_riskMed_16.png\">" : val="Medium"; break;
          	case "<img src=\"/images/icn_riskHigh_16.png\">" : val="High"; break;
        }
      } else if( ftype == "status") {
        switch(val){
          case "<img src=\"/images/icn_attackDetected_16.png\">\n      " : val="Detected"; break;
          case "<img src=\"/images/icn_attackBlocked_16.png\">\n      " : val="Blocked"; break;
        }
      }

      var object = {text: val, coltype : ftype};
      createRow(object);
      
      $(".context-menu").fadeOut();      
      
      submitFilter();
    });
  
  $("#submit_link").click(submitFilter);

  $(".block-link").click(openBlockPanel);

  $(".host-lookup-link").click(openHostNameLookupPanel);

  $(".xforce-link").click(function(){
      var val = document.issueid;
      window.open('http://www.iss.net/security_center/reference/'+val+'.html', 'window_'+val, 'toolbar=0, width=900, height=700, menubar=0, scrollbars=1, resizable=1');
      $(".context-menu").fadeOut();      
    }
  );
});


