"use strict";

var showPolling = function(){
	var $dialog = $("<div><p>Loading please wait...</p></div>").dialog(
								{
									autoOpen:true, 
									show:'puff', 
									hide:'puff', 
									modal: false, 
									position: "center",
									resizable: false,
									draggable: false,
									dialogClass: "alert-loading-modal"
								});
   return $dialog;
};

var hidePolling = function(dialog){
	dialog.dialog("close");
};

var createAddRemoveLinks = function(action, id){
  var elm = $(document.createElement('a'));
  if(action === "add"){
    elm.html("<img src='/images/add.png' />");
    elm.click(createRow, filterRows().next);
  }else{
    elm.html("<img src='/images/delete.png' />");
    elm.click(removeRow);
  }
  
  return elm; 
};

var displaySaveFilter = function(){
    $("#save_filter_div").show();
};

var filterRows = function () {
  var rows = $("#filter-criteria-list");
  
  return {
      current : rows.children().length,
      next : rows.children().length + 1 
  };
};

var logFilter = function () {
  var ftype = $("#filter_type").val();

  return {
    type : ftype,
    path : ftype + "_logs" 
  };
};

var getQueryString = function(){
  if(document.query_string === undefined){document.query_string = "?";}
  return document.query_string;    
};

var dateTime = function(){
  date_obj = new Date();
  date_obj_hours = date_obj.getHours();
  date_obj_mins = date_obj.getMinutes();

  if (date_obj_mins < 10) { date_obj_mins = "0" + date_obj_mins; }

  if (date_obj_hours > 11) {
      date_obj_hours = date_obj_hours - 12;
      date_obj_am_pm = " PM";
  } else {
      date_obj_am_pm = " AM";
  }

  date_obj_time = "'"+date_obj_hours+":"+date_obj_mins+date_obj_am_pm+"'";
  return date_obj_time;
};

var clearFilter = function(){
  var path = logFilter().path;
  document.location = "/"+path;
};

var openHostNameLookupPanel = function(){
  $("#host_name_lookup").css({"left":document.clickpos.left, "top":document.clickpos.top}).fadeIn("slow"); 
};

var closeHostNameLookupPanel = function(){
  $("#host_name_lookup").fadeOut("slow");
};

var getFilterDisplayed = function(){
  if(document.filter_displayed === undefined){document.filter_displayed = "false";}
  return document.filter_displayed;
};


var loadPage= function(arg){
  var path = logFilter().path;
	var $dialog = showPolling();
  $("#syslog").load("/"+path+"/"+arg, function(){
		hidePolling($dialog);
	});
};


var loadOlderPage = function(){
  var path = logFilter().path;
  $("#syslog").load("/"+path+"/page_older");
};


var loadNewestPage = function(){
  var path = logFilter().path;
  $("#syslog").load("/"+path+"/page_newest");
};


var loadOldestPage = function(){
  var path = logFilter().path;
  $("#syslog").load("/"+path+"/page_oldest");
};


var closeManageFilters = function(){
  $("#manage_saved_filters").fadeOut("slow");
};


var showDatetime = function(){
  $("#timecol").fadeIn("slow");
};


var hideDatetime = function(){
  $("#timecol").fadeOut("slow"); 
};




var confirmDelete = function(id){
  $("#load_link"+id).fadeOut("normal", function(){
    $("#cancel_link"+id).fadeIn();
  });

  $("#delete_link"+id).fadeOut("normal", function(){
    $("#confirm_delete"+id).fadeIn();
  });
};


var cancelDelete = function(id){
  $("#cancel_link"+id).fadeOut("normal", function(){
    $("#load_link"+id).fadeIn();
  });

  $("#confirm_delete"+id).fadeOut("normal", function(){
    $("#delete_link"+id).fadeIn();
  });
};

var deleteFilter = function(id){
  var path = logFilter().path;

   $.ajax({
    url: "/lmi_filters/"+id,
    type: "delete",
    success: function(res){
       $("#manage_saved_filters").load("/"+path+"/manage_filters?fmt=xhr");
    }
  });
};


var getStartTime = function(){
  var date_string = $("#start_time").attr("value")+" "+$("#date_start_time_4i").attr("value")+":"+$("#date_start_time_5i").val()+" UTC";
  var start = new Date(date_string);
  return start.getTime();
};



var getEndTime = function(){
  var date_string = $("#end_time").attr("value")+" "+$("#date_end_time_4i").attr("value")+":"+$("#date_end_time_5i").val()+" UTC";
  var end = new Date(date_string);
  return end.getTime();
};


var validStartTime = function(){
  if($("#start_time").attr("value") == ""){return false;}
  return true;  
};


var validEndTime = function(){
  if($("#end_time").attr("value") == ""){return false;}
  return true;  
};

var registerListeners = function(){
  if(document.addEventListener){
    document.addEventListener('keypress', checkKey, false);
  }else if(document.attachEvent){
    document.attachEvent('onkeypress', checkKey);
  }     
};

var removeRow = function(){
  $(this).parent().remove();
  if(filterRows().current === 0){createRow(this);}
};


var setFocus = function(){
  document.save_focus = true;
};


var setBlur = function(){
  document.save_focus = false;
};


var cleanRows = function(){
  var nrows = filterRows().current;

  if(nrows > 0){
    for(var i=0; i<=nrows; i++){
      if($("#filter_criteria_"+i+"_text").attr("value") == ""){
        $("#li_"+i).remove();
      }
    }
  }
};


var resetTime = function(){
  $("#date_start_time_4i").attr("value", "00");
  $("#date_start_time_5i").attr("value", "00");
  $("#date_end_time_4i").attr("value", "00");
  $("#date_end_time_5i").attr("value", "00");
  $("#start_time").attr("value", "");
  $("#end_time").attr("value", "");
};

var filterTimeRange = function(){
  hideDatetime();

  var type = $("#time_select").val();
  
  if(type=="custom"){
    showDatetime();
  }else if (type=="stream") {
    startLiveView(); 
  }
};




