"use strict";

var criteria_empty = true;

var buildDateFilters = function(qs){
  var start_param = qs.get("date[start_time]");
  var end_param = qs.get("date[end_time]");
  
  if(start_param !== undefined){
    var start_time = new Date(parseInt(start_param, 10));
    $("#start_time").attr("value", start_time.format("mm/dd/yyyy"));
    $("#date_start_time_4i").attr("value", start_time.format("HH"));
    $("#date_start_time_5i").attr("value", start_time.format("MM"));
    qs.size -= 1;
  }
  
  if(end_param !== undefined){
    var end_time = new Date(parseInt(end_param, 10));
    $("#end_time").attr("value", end_time.format("mm/dd/yyyy"));
    $("#date_end_time_4i").attr("value", end_time.format("HH"));
    $("#date_end_time_5i").attr("value", end_time.format("MM"));
    qs.size -= 1;
  }
  return qs;
};

var createFilterListItem = function(){
  var elm = $(document.createElement('li'));
  elm.attr("class", "filter_li");
  elm.attr("id", "li_"+filterRows().next);
  return elm;
};


var getFilterData = function(){
  var filter_data = {};

  criteria_empty = true;
	var ts = $("#time_select").attr("value");
	if(ts !== ""){criteria_empty = false;}
	
  filter_data.time_select = $("#time_select").attr("value");

  $(".filter_criteria").each(function(){
    if($(this).attr("value") !== ""){
      criteria_empty = false;
    }
    filter_data[$(this).attr("name")]= $(this).attr("value");
    }
  );

    if(criteria_empty)
        filter_data = {};
      
    return filter_data;
}

var timeRangeSelect = function(arg){
    return (arg == "time_select") || (arg == "date[start_date]") || (arg == "date[start_time]") ||  (arg == "date[end_time]");
}

var createFilterTextBox = function(object, id){
  var input = $(document.createElement('input'));
  input.attr("class", "filter_criteria");
  input.attr("id", "filter_textbox_"+id);
  input.attr("name", "filter[textbox_"+id+"]");
  input.attr("value", object.text);
  input.attr("size", "20");
  input.attr("type", "text");
  return input;
};

var createRow = function(object){
  var id = filterRows().next;
  if(object === undefined){object = {"text": ""};}

  var li = createFilterListItem(); 
  li.append(createFilterTextBox(object, id));
  li.append(createAddRemoveLinks("add"));
  li.append(createAddRemoveLinks("del")); 
  $("#criteria_table ul").append(li);
  $("#criteria_table ul li").fadeIn("slow");
};

var buildDateFilters = function(qs){
  var start_param = qs.get("date[start_time]");
  var end_param = qs.get("date[end_time]");
  
  if(start_param !== undefined){
    var start_time = new Date(parseInt(start_param, 10));
    $("#start_time").attr("value", start_time.format("mm/dd/yyyy"));
    $("#date_start_time_4i").attr("value", start_time.format("HH"));
    $("#date_start_time_5i").attr("value", start_time.format("MM"));
    qs.size -= 1;
  }
  
  if(end_param !== undefined){
    var end_time = new Date(parseInt(end_param, 10));
    $("#end_time").attr("value", end_time.format("mm/dd/yyyy"));
    $("#date_end_time_4i").attr("value", end_time.format("HH"));
    $("#date_end_time_5i").attr("value", end_time.format("MM"));
    qs.size -= 1;
  }
  return qs;
};


var buildFilterList = function(qs){
  var object = {};
  $("#time_select").attr("value", qs.get("time_select"));
  $(".filter_li").remove();
  if((qs.get("date[end_time]") !== undefined || qs.get("date[start_time]") !== undefined)){
    $("#show_datetime_link span span").load("/messages/hide_time_filter_tag");
    $("#timecol").fadeIn("slow");
    qs = buildDateFilters(qs);
  }else{
    $("#timecol").hide();
    $("#show_datetime_link span span").load("/messages/time_filter_tag");
  }
 
  for(var i = 0; i < qs.size; i++){
    if(qs.keys[i].match(/filter\[textbox\_/)){
        object.text = qs.get(qs.keys[i]);
        createRow(object);
    }
  }
};



var submitFilter = function(){
  var $dialog = showPolling();
  var path = logFilter().path;
  clearError();
  var filter_data = getFilterData();
  
  if(validStartTime()){
    filter_data["date[start_time]"] = getStartTime();
    criteria_empty = false;
  }

  if(validEndTime()){
    filter_data['date[end_time]'] = getEndTime();
  }
   
  $("#syslog").load("/"+path+"/load_filter?"+$.param(filter_data));
  $("#show_save_filter_button").fadeIn("slow");
	hidePolling($dialog);
};


var saveFilter = function(){
  var type = logFilter().type;
  var path = logFilter().path;

  clearError();

  if($("#save_tag_tb").attr("value") === ""){
    raiseError('missing_save_filter_tag');
    return false;
  }

  $("#save_filter_link_span").fadeIn("slow");
  

  var filter_data = {};  
  filter_data.time_select = $("#time_select").attr("value");
  filter_data.filter_tag = $("#save_tag_tb").attr("value");
  filter_data.fmt = "xhr";
  filter_data.type = type;




  $(".filter_criteria").each(function(){
		if($(".filter_criteria").length === 1 && $(this).val() == ""){
			$(this).val(" ");
		}
    if($(this).val() !== ""){
        filter_data[$(this).attr("name")] = $(this).attr("value"); 
    }  
  });

  
  if(validStartTime()){filter_data['date[start_time]']= getStartTime();}
  if(validEndTime()){filter_data['date[end_time]'] = getEndTime();}
  
  $.ajax({
    url: "/lmi_filters",
    type: "post",
    data: filter_data,
    error: function(){
      alert('Error loading XML document');
    },
    success: function(res){
      if($(res).attr("class") === "error"){ 
        $("#save_filter_message_div").html(res).fadeIn("slow");
      }else{
        $("#save_filter_message_div").html(res).fadeIn("slow").fadeOut(4000);
      }
      
      $("#manage_saved_filters").load("/"+path+"/manage_filters"); 
    }
  });
};

var loadFilter = function(id, qs){
  var $dialog = showPolling();
  $(".load-filter-tag").removeClass("load-filter-tag-filtered");
  $("#load-filter-tag"+id).addClass("load-filter-tag-filtered");

  var path = logFilter().path;

  clearError();
  qs = new Querystring(qs);
  $("#syslog").load("/"+path+"/load_saved_filter?id="+id, function(){
		hidePolling($dialog);
	}); 
  buildFilterList(qs);
};

var loadPredefinedFilter = function(id, qs){
  var $dialog = showPolling();
  $(".load-filter-tag").removeClass("load-filter-tag-filtered");
  $("#load-filter-tag"+id).addClass("load-filter-tag-filtered");

  var path = logFilter().path;

  clearError();
  qs = new Querystring(qs);
  $("#syslog").load("/"+path+"/load_saved_filter?id="+id, function(){
		hidePolling($dialog);
	}); 
};


var loadLiveView = function(arg){
   var filter_data = getFilterData();
   var path = logFilter().path;
  $("#syslog").load("/"+path+"/refresh?"+$.param(filter_data));
};


var startLiveView = function(){
  $("#time_filter_link").hide();
  $("#timecol").hide();
  if(!document.live_view_interval){document.live_view_interval = setInterval("loadLiveView()", 3000);}
};


var stopLiveView = function(){
  clearInterval(document.live_view_interval);
  $("#time_filter_link").show();
  document.live_view_interval = undefined;
  var filter_data = getFilterData();
  var path = logFilter().path;

  document.location = "/"+path+"?"+$.param(filter_data);
};



var checkKey = function(e) {
  var filter_type = $("#filter_type").attr("value");  
  if(!e){e = window.event;}
  if (e.keyCode){code = e.keyCode;}
  else if(e.which){code = e.which;}
  
  if(code === 13){ 
    if(document.save_focus){
      saveFilter(filter_type);
    }
    else{submitFilter();
    }
  } 
};

function determine_btn_state(btn,streaming) {
  if ($("#"+btn).hasClass("btn") && streaming == "true") {
    $("#"+btn).removeClass("btn");
    $("#"+btn).addClass("inactive");
  }
}

$(document).ready(function(){
    var qs = new Querystring();

    if (qs.contains_filter_data) {
      buildFilterList(qs);
    } else {
      createRow();
    }
    registerListeners();    
    filterTimeRange();
    $("#reset_filter_link").click(clearFilter);
    $("#start_time").datepicker(); 
    $("#end_time").datepicker();

    $("#stream-link").click(function(){
        var is_streaming = $("#stream-link").data("streaming");

        if(is_streaming === "false" || typeof(is_streaming) == "undefined"){
            $("#stream-link").data("streaming", "true");
            determine_btn_state("newest_btn","true");
            determine_btn_state("newer_btn","true");
            determine_btn_state("oldest_btn","true");
            determine_btn_state("older_btn","true");
            $("#time_filter").fadeOut();
            $("#time_filter_stream").fadeIn();
            startLiveView();
            $("#stream-widget").css({"background-image": "url(/images/small_ajax_loader.gif)"});
            $(this).html("<span><span>Stop Stream</span></span>");
        }else{
            stopLiveView();
            $("#stream-widget").css({"background-image": "none"});
            $("#stream-link").data("streaming", "false");
            $(this).html("<span><span>Stream Live Data</span></span>");
        }
    });

    

    $("#close_save_filter_link").click(function(){
      clearError();
      $("#save_filter_div").fadeOut("slow");
    });
});

