/*
  Accepts an html element's id and an arry of data.
  Uses the id to determine which graph to pupulate with
  passed in data.
*/
function renderTop10Graph(elm, data_source, data){
  var data_points = new Array();
  var i = 0;

  function showTooltip(x, y, contents){
    $('<div id="tooltip">' + contents + '</div>').css( {
      position: 'absolute',
      display: 'none',
      top: y + 5,
      left: x + 5,
      border: '1px solid #fdd',
      padding: '2px',
      'background-color': '#fee',
      opacity: 0.80
     }).appendTo("body").fadeIn(200);
  }

  function enableToolTips(){
    var previousPoint = null;
  
    $(elm).bind("plothover", function (event, pos, item){

    $("#x").text(pos.x.toFixed(2));
    $("#y").text(pos.y.toFixed(2));

    if(item){
      if(previousPoint != item.datapoint){
        previousPoint = item.datapoint;
        $("#tooltip").remove();
        var x = item.datapoint[0].toFixed(2);
        var y = item.datapoint[1].toFixed(2);
        showTooltip(item.pageX, item.pageY,
                    parseInt(x) +" attacks");
      }
    }else{
      $("#tooltip").remove();
        previousPoint = null;            
      }
    });
  }

//data = [["225","172.16.22.1"], ["250", "172.16.22.2"], ["275", "172.16.22.3"], ["300", "172.16.22.4"],["325", "172.16.22.5"], ["350", "172.16.22.6"], ["375", "172.16.22.7"], ["400", "172.16.22.8"], ["425", "172.16.22.9"], ["450", "172.16.22.10"]];
  if(data.length > 0){
    var ticks_arr = new Array();
    var min_value = -1;
    var max_value = 0;
    $.each(data, function(index, value){
      var attacks = parseInt(value[1]);
      if (min_value > attacks || min_value == -1) {
        min_value = attacks;
      }
      if (max_value < attacks) {
        max_value = attacks;
      }
      data_points[i] = {data: [[attacks,i]]};
      ticks_arr[i] = new Array();
      ticks_arr[i][0] = i;
      ticks_arr[i++][1] = value[0];
    })

    min_value = parseInt(min_value - (min_value*.10));
    max_value = parseInt(max_value + (max_value*.10));
    
    enableToolTips();
    removeLoadingMsg("#loading_graph_small_"+data_source);
    
    $.plot($(elm), data_points, optionsTop10(ticks_arr,min_value,max_value));
  }else{
    removeLoadingMsg("#loading_graph_small_"+data_source);
    $(elm).attr("class", "empty-graph-msg").html("No data to display").fadeIn();  
  }
}

/*
  Options for the main graph 
*/
function optionsTop10(ticks_arr,min_value,max_value){
  var options = {
    bars: { show: true, fill: .75, horizontal: true, align: "center"}, 
    yaxis: {min: -1, max: 10, ticks: ticks_arr},
    xaxis: {min: min_value, max: max_value},
    grid:{hoverable:true,
    markings: function () {
      var markings = [];
      for (var y = -1; y < 10; y += 1)
        markings.push({ yaxis: { from: y, to: y } });  
      return markings;
    }}
  };
  return options;
}


  

